#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("tune=native")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct E {
    ll t, f;
};

bool operator<(const E &a, const E &b) {
    if (a.t != b.t) return a.t < b.t;
    if (a.f != b.f) return a.f;
    return 0;
}

int main() {
#ifndef AVEVAD
    cin.tie(0);
    ios_base::sync_with_stdio(0);
#endif
    ll n, m, q;
    cin >> n >> m >> q;
    ll add = 0;
    vector<E> v;
    while (n--) {
        ll l, r;
        cin >> l >> r;
        l--;
        ll bl = (l + m - 1) / m;
        ll br = r / m;
        add += br - bl;
        ll kl = l % m, kr = r % m;
        if (l / m == r / m) {
            v.push_back({kl, 1});
            v.push_back({kr, 0});
        } else {
            v.push_back({kl, 1});
            v.push_back({m, 0});
            v.push_back({0, 1});
            v.push_back({kr, 0});
        }
    }
    sort(v.begin(), v.end());
    map<ll, ll> d;
    ll c = 0;
    d[0] = 0;
    for (E e : v) {
        if (e.f) c++;
        else c--;
        d[e.t] = c;
    }
    ll ans = 1e18;
    for (auto p : d) if (p.first != m) ans = min(ans, p.second);
    ans += add;
    cout << ans << '\n';
}