#include <algorithm>
#include <iostream>
#include <vector>

void increment(long long l, long long r, std::vector<long long>& a)
{
    for (long long i = l; i < r; ++i) {
	++a[i];
    }
}

int main()
{
    long long n, m, q;
    std::cin >> n >> m >> q;
    long long ans = 0;
    std::vector<long long> cnt(m, 0);
    for (long long i = 0; i < q; ++i) {
	long long l, r;
	std::cin >> l >> r;
	--l, --r;
	if (l / m == r / m) {
	    increment(l % m, r % m + 1, cnt);
	} else {
	    increment(l % m, m, cnt);
	    increment(0, r % m + 1, cnt);
	    ans += (r / m) - (l / m) - 1;
	}
    }
    long long mn = n;
    for (auto i: cnt) mn = std::min(mn, i);
    std::cout << ans + mn << '\n';
    return 0;
}

