#include <bits/stdc++.h>
using namespace std;

#define rep(i, a, b) for (int (i) = a; (i) < (b); ++(i))
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

template<typename T1, typename T2>
bool ckmin(T1& a, const T2& b) {
    return a > b && (a = b, true);
}

template<typename T1, typename T2>
bool ckmax(T1& a, const T2& b) {
    return a < b && (a = b, true);
}

bool comp(const vi& a, const vi& b) {
    bool was = false;
    rep(i, 0, sz(a)) {
        if (a[i] != b[i]) {
            if (was) return false;
            was = true;
        }
    }
    return true;
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(ios::failbit);

    int n, k, a;
    cin >> n >> k >> a;
    string alp;
    cin >> alp;

    vector<vi> s(n);
    rep(i, 0, n) {
        string ss;
        cin >> ss;
        rep(j, 0, k) s[i].push_back(find(all(alp), ss[j]) - begin(alp));
    }

    vector<vi> ans(n);
    vi cnta(n);

    vi word(k, 0);

    auto update = [&]() {
        int cnt = 0, lst = -1;
        rep(i, 0, n) {
            if (comp(word, s[i])) {
                cnt++, lst = i;
            }
        }

        if (cnt == 1) {
            ans[lst] = word, cnta[lst]++;
        }
    };

    vi mx(k, a - 1);
    while (word != mx) {
        update();

        word[0]++;
        rep(i, 0, k - 1) word[i + 1] += word[i] / a, word[i] %= a;
    }
    update();

    rep(i, 0, n) {
        cout << cnta[i] << ' ';
        if (cnta[i] > 0) {
            for (auto en: ans[i]) cout << alp[en];
        }
        cout << '\n';
    }
}