#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <cmath>

typedef long long ll;

#define all(x) (x).begin(), (x).end()
#define pb(x) push_back(x)

using namespace std;

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    ll n, m; cin >> n >> m;

    vector<pair<ll, ll> > v;

    ll l1, r1, l2, r2;
    for (int i = 0; i < n; ++i) {
        cin >> l1 >> r1 >> l2 >> r2;

        v.pb(make_pair(l1, r1));
        v.pb(make_pair(l2, r2));
    }

    vector<vector<ll> > p(n, vector<ll>(2));

    ll res = 0;
    for (int i = 0; i < m; ++i) {
        cin >> l1 >> r1;

        ll l = 0;
        ll r = n*2;

        while (r - l > 1){
            ll md = (r + l)/2;

            if (v[md].first <= l1) l = md;
            else r = md;
        }
        if (v[l].first > l1 || v[l].second < l1) {res += 1; continue;}
        else ++p[l/2][l%2];
    }

    for (int i = 0; i < n; ++i){
        res += max(p[i][0], p[i][1]);
    }
    cout << res;
    return 0;
}
