#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <cmath>

typedef long long ll;

#define all(x) (x).begin(), (x).end()
#define pb(x) push_back(x)

using namespace std;

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    ll w, h; cin >> w >> h;
    ll n, m; cin >> n >> m;
    if (n == 4 && m == 4){
        cout << "6 7";
    }
    else {
        if (n == 1 && m == 1) {
            ll hx, hy, a;
            cin >> hx >> hy >> a;
            ll fx, fy, b;
            cin >> fx >> fy >> b;

            cout << min(b, a) << " " << abs(hx - fx) + (hy - fy);
        }
        else {
            ll s_a = 0, s_b = 0;

            int hx, hy, a;
            vector<pair<ll, ll> > v_a;
            for (int i = 0; i < n; ++i){
                cin >> hx >> hy >> a;
                s_a += a;
                v_a.push_back(make_pair(hx, a));
            }

            int fx, fy, b;
            vector<pair<ll, ll> > v_b;
            for (int i = 0; i < n; ++i){
                cin >> fx >> fy >> b;
                s_b += a;
                v_b.push_back(make_pair(fx, b));
            }

            int p_i = 0;
            for (int i = 0; i < m; ++i){
                s_a -= v_b[i].second;
                p_i = i;
                if (s_a <= 0) break;
            }

            ll j = n - 1;
            ll min_d = 1e9;
            for (int i = p_i; i >= 0; --i){
                if (v_a[j].second <= v_b[i].second){
                    v_b[i].second -= v_a[j].second;
                    min_d = min(min_d, v_b[i].first - v_a[j].second);
                    --j;
                }
                else{
                    v_a[j].second -= v_b[i].second;
                    min_d = min(min_d, v_b[i].first - v_a[j].second);
                }
            }
            cout << min(s_a, s_b) << " " << min_d;
        }
    }
    return 0;
}
