#include<iostream>
#include <vector>
#include <string>
#include <math.h>
#include <algorithm>
#include <set>
#include <map>
using namespace std;
typedef long long ll;
vector<int> g[200002];
int d[200002], u[200002];
void dfs(int x, int px) {
	d[x] = 1;
	for (auto& i : g[x]) {
		if (i != px && !u[i]) {
			dfs(i, x);
			d[x] += d[i];
		}
	}
}
int fnd(int x, int px, int sz) {
	for (auto& i : g[x]) {
		if (i != px && !u[i] && d[i] * 2 >= sz) return fnd(i, x, sz);
	}
	return x;
}
signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	int n; cin >> n;
	for (int i = 0; i < n - 1; ++i) {
		int x, y;
		cin >> x >> y; --x, --y;
		g[x].push_back(y);
		g[y].push_back(x);
	}
	int x = 0;
	while (1) {
		dfs(x, x);
		x = fnd(x, x, d[x]);
		cout << x + 1 << endl;
		int y; cin >> y; y--;
		if (y == -1) {
			cout << "! " << x + 1 << endl;
			exit(0);
		}
		u[x] = 1;
		x = y;
	}
}