#include<iostream>
#include <vector>
#include <string>
#include <math.h>
#include <algorithm>
#include <set>
#include <map>
using namespace std;
typedef long long ll;

int u[10000002];

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	u[1] = 1;
	for (int i = 2; i <= 1e7; ++i) {
		if (!u[i]) {
			for (ll j = i; j <= 1e7; j += i) {
				if (!u[j]) u[j] = i;
			}
		}
	}
	int t; cin >> t;
	vector <int> v, w;
	while (t--) {
		int a, b; cin >> a >> b;
		v.clear();
		w.clear();
		while (a != 1) {
			v.push_back(u[a]);
			a /= u[a];
		}
		while (b != 1) {
			w.push_back(u[b]);
			b /= u[b];
		}
		int res = 1;
		while (w.size() && v.back() == w.back()) {
			res *= w.back();
			w.pop_back();
			v.pop_back();
		}
		cout << res << '\n';
	}
}