#include<iostream>
#include <vector>
#include <string>
#include <math.h>
#include <algorithm>
#include <set>
#include <map>
using namespace std;
typedef long long ll;

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	int n, m, q; cin >> n >> m >> q;
	map<pair<int, int>, int> w;
	while (q--) {
		int l, r; cin >> l >> r;
		l = (l - 1) % m;
		r = (r - 1) % r;
		if (l > r) {
			w[{ l, 1 }] ++;
			w[{ 0, 1 }]++;
			w[{ m, 0 }]++;
			w[{ r + 1, 0 }]++;
		}
		else {
			w[{ l, 1 }]++;
			w[{ r + 1, 0 }]++;
		}
	}
	int res = 1e9, now = 0;
	for (auto& i : w) {
		if (i.first.second) {
			now += i.second;

		}
		else {

			res = min(res, now);
			now -= i.second;
		}
	}
	cout << res;
}