#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <string>
#include <deque>
#include <algorithm>
#include <iomanip>
#include <unordered_map>
#include <cmath>

using namespace std;

typedef long long ll;
const ll inf = 1e9;
const ll mod = 1e9 + 7;



int main() {
	int n;
	cin >> n;
	if (n <= 20) {
		for (int i = 1; i != 21; i++) {
			cout << "? " << i;
			fflush(stdout);
			string s;
			cin >> s;
			if (s == to_string(i)) {
				cout << "! " << i << endl;
				return 0;
			}
		}
	}
	vector <int> v(n);
	map<int, int> m;
	for (int i = 0; i != n - 1; i++) {
		int a, b;
		cin >> a >> b;
		if (b > a) m[a] = b;
		else m[b] = a;
	}
	v[0] = 1;
	for (int i = 0; i != n - 1; i++) {
		v[i + 1] = m[v[i]];
	}
	int r = n - 1, l = 0;
	while (r - l != 1) {
		int to = (r + l) / 2;
		cout << "? " << v[to] << endl;
		fflush(stdout);
		string s;
		cin >> s;
		if (s == to_string(v[to])) {
			cout << "! " << v[to] << endl;
			fflush(stdout);
			return 0;
		}
		if (to > 0 && s == to_string(v[to - 1])) {
			l = to;
		}
		else {
			r = to;
		}
	}
	cout << "? " << v[r] << endl;
	fflush(stdout);
	string s;
	cin >> s;
	if (s == to_string(v[r])) {
		cout << "! " << v[r] << endl;
		fflush(stdout);
		return 0;
	}
	else {
		cout << "! " << v[l] << endl;
		fflush(stdout);
		return 0;
	}
}