#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <string>
#include <deque>
#include <algorithm>
#include <iomanip>
#include <unordered_map>
#include <cmath>

using namespace std;

typedef long long ll;
const ll inf = 1e9;
const ll mod = 1e9 + 7;



int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t;
	cin >> t;
	while (t--) {
		int a, b;
		cin >> a >> b;
		int na = 1, nb = 1;
		for (int i = 2; i <= sqrt(a); i++) {
			if (i % a == 0) {
				na = a / i;
				break;
			}
		}
		for (int i = 2; i <= sqrt(b); i++) {
			if (i % b == 0) {
				nb = b / i;
				break;
			}
		}
		if (b % na != 0 || a % nb != 0) {
			cout << -1 << endl;
			continue;
		}
		if (a == b) {
			cout << a << endl;
			continue;
		}
		cout << min(na, nb) << endl;
	}
}