#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <string>
#include <deque>
#include <algorithm>
#include <iomanip>
#include <unordered_map>
#include <cmath>

using namespace std;

typedef long long ll;
const ll inf = 1e9;



int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);

	int n, m, q;
	cin >> n >> m >> q;
	vector <int> v(m + 1);
	for (int i = 0; i != q; i++) {
		int l, r;
		cin >> l >> r;
		l %= m;
		r %= m;
		if (l > r) swap(l, r);
		v[l] += 1;
		v[r + 1] -= 1;
	}
	int sum = 0;
	for (int& i : v) {
		sum += i;
		i = sum;
	}
	v[m] = inf;
	int ans = inf;
	for (int i : v) ans = min(ans, i);
	cout << ans;
}