#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <ctime>
#include <random>
#include <bitset>
#include <iomanip>
#include <chrono>
#include <algorithm>
#include <queue>
#include <deque>

#include <ext/pb_ds/assoc_container.hpp> // РћР±С‰РёР№ С„Р°Р№Р».
#include <ext/pb_ds/tree_policy.hpp> // РЎРѕРґРµСЂР¶РёС‚ РєР»Р°СЃСЃ tree_order_statistics_node_update

using namespace std;
using namespace __gnu_pbds;

// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx,avx2,fma,tune=native")

typedef long long ll;
typedef long double ld;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define int int_fast32_t
#define trace(x) cout << #x << " = " << x << endl;
#define trace2(x, y) cout << #x << " = " << x << ' ' << #y << " = " << y << endl;
#define trace3(x, y, z) cout << #x << " = " << x << ' ' << #y << " = " << y << ' ' << #z << " = " << z << endl;
#define trace4(x, y, z, a) cout << #x << " = " << x << ' ' << #y << " = " << y << ' ' << #z << " = " << z << ' ' << #a << " = " << a << endl;
#define trace_name(x) cout << #x << " = ";
#define trace_all_in(x) cout << #x << " = "; for (auto i : x) cout << i << ' '; cout << endl;

mt19937 rnd(time(0));

const ll INF = (ll)(1e18);
const ll MOD = (ll)(1e9 + 7);  // 998244353; //
const ld EPS = (ld)(1e-10);
const ld PI = acos(-1);

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cout << fixed << setprecision(30);
}

template <typename T>
using ordered_set =  tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update>;

void solve() {
    ll a, b;
    cin >> a >> b;

    if (min(a, b) == 1) {
        cout << "1\n";
        return;
    }
    if (a == b) {
        cout << a << '\n';
        return;
    }

    set<ll> diff_dels;
    map<ll, ll> cnt_a, cnt_b;

    for (ll i = 2; i * i <= a; ++i) {
        if (a % i) continue;

        diff_dels.insert(i);
        ll cnt = 0;
        while (a % i == 0) {
            a /= i;
            ++cnt;
        }

        cnt_a[i] = cnt;
    }
    if (a != 1) {
        ++cnt_a[a];
        diff_dels.insert(a);
    }

    for (ll i = 2; i * i <= b; ++i) {
        if (b % i) continue;

        diff_dels.insert(i);
        ll cnt = 0;
        while (b % i == 0) {
            b /= i;
            ++cnt;
        }

        cnt_b[i] = cnt;
    }
    if (b != 1) {
        diff_dels.insert(b);
        cnt_b[b]++;
    }

    ll mnog = 1;
    for (auto it = diff_dels.end(); it != diff_dels.begin(); --it) {
        auto now_it = it;
        --now_it;

        ll k = *now_it;
        if (cnt_a[k] != cnt_b[k]) {
            for (ll i = 0; i < min(cnt_a[k], cnt_b[k]); ++i) {
                mnog *= k;
            }
            cout << mnog << '\n';
            return;
        }
        for (ll i = 0; i < min(cnt_a[k], cnt_b[k]); ++i) {
            mnog *= k;
        }
    }
}

signed main() {
//    freopen("mountain.in", "r", stdin);
//    freopen("mountain.out", "w", stdout);

    fast_stream();

    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
}

/*

0 1
0 0
1 0
0 -1

*/