//#pragma comment(linker, "/STACK:130000000")
#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <set>
using namespace std;

inline void start() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	//freopen("input.txt", "rt", stdin);
	//freopen("output.txt", "wt", stdout);
}

const int N = 2e5 + 10;
vector<int> g[N];
int up[N][20], tin[N], tout[N], timer, dist[N];
queue<int> le;

void dfs(int v, int p) {
	dist[v] = dist[p] + 1;
	tin[v] = timer++;
	up[v][0] = p;
	for (int i = 1; i < 20; i++)
		up[v][i] = up[up[v][i - 1]][i - 1];
	for (int to : g[v])
		if (to != p)
			dfs(to, v);
	if (v != 1 && g[v].size() == 1)
		le.push(v);
	tout[v] = timer++;
}

bool upper(int v, int u) {
	return tin[v] <= tin[u] && tout[u] <= tout[v];
}

int move(int v, int len) {
	for (int i = 19; i >= 0; i--)
		if ((1 << i) <= len) {
			v = up[v][i];
			len -= (1 << i);
		}
	return v;
}

int main() {
	start();
	int n;
	cin >> n;
	for (int i = 0; i < n - 1; i++) {
		int v, u;
		cin >> v >> u;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	dfs(1, 0);
	int l = 1, r = le.front();
	le.pop();
	while (1) {
		while (l != r) {
			int mid = move(r, (dist[r] - dist[l]) >> 1);
			cout << mid << endl;
			int x;
			cin >> x;
			if (x == 0) {
				cout << "! " << mid << endl;
				return 0;
			}
			if (up[x][0] == r) {
				while (!upper(x, le.front()))
					le.pop();
				l = x;
				r = le.front();
				le.pop();
			}
			else if (x == l || !upper(x, r)) {
				while (!le.empty() && !upper(l, le.front()))
					le.pop();
				if (le.empty()) {
					cout << "! " << l << endl;
					return 0;
				}
				l = x;
				r = le.front();
				le.pop();
			}
			else if (x == up[mid][0]) {
				r = x;
			}
			else {
				l = x;
			}
		}
		cout << l << endl;
		int x;
		cin >> x;
		if (x == 0) {
			cout << "! " << l << endl;
			return 0;
		}
		while (!upper(x, le.front()))
			le.pop();
		l = x;
		r = le.front();
		le.pop();
	}
	return 0;
}