#pragma comment(linker, "/STACK:130000000")
#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <fstream>
#include <vector>
#include <map>
using namespace std;

inline void start() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
}

const int N = 1e4;
vector<int> prime;
bool notPrime[N];

void f() {
	for(int i = 2; i < N; i++)
		if (!notPrime[i]) {
			prime.push_back(i);
			for (int j = i * i; j < N; j += i)
				notPrime[j] = 1;
		}
}

int main() {
	start();
	f();
	int t;
	cin >> t;
	while (t--) {
		int a, b;
		map<int, int> qa, qb;
		cin >> a >> b;
		if (a > b)
			swap(a, b);
		int ans = min(a, b);
		for (int i = 0; i < (int)prime.size() && a > 1; i++)
			while (a % prime[i] == 0) {
				qa[prime[i]]++;
				a /= prime[i];
			}
		if (a > 1)
			qa[a]++;
		for (int i = 0; i < (int)prime.size() && b > 1; i++)
			while (b % prime[i] == 0) {
				qb[prime[i]]++;
				b /= prime[i];
			}
		if (b > 1)
			qb[b]++;
		for(auto i : qa)
			if (i.first != qb.begin()->first &&
				i.second > qb[i.first]) {
				ans = 1;
				break;
			}
		for (auto i : qb)
			if (i.first != qa.begin()->first &&
				i.second > qa[i.first]) {
				ans = 1;
				break;
			}
		cout << ans << '\n';
	}
	return 0;
}