#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <deque>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e18;
const ld EPS = 1e-9;
const ll MOD = 1000000000 + 7;
const ld PI = acos(-1);

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n;
	cin >> n;
	while (n--) {
		ll a, b;
		cin >> a >> b;
		set<ll> s = { a };
		ll i = 2;
		while (i * i <= a) {
			while (a % i == 0) {
				a /= i;
				s.insert(a);
			}
			i++;
		}
		s.insert(1);
		if (s.find(b) != s.end()) {
			cout << b << "\n";
			continue;
		}
		i = 2;
		bool kk = 0;
		while (i * i <= b) {
			while (b % i == 0) {
				b /= i;
				if (s.find(b) != s.end()) {
					cout << b << "\n";
					kk = 1;
					break;
				}
			}
			if (kk) break;
			i++;
		}
		if (!kk) cout << 1 << "\n";
	}
	return 0;
}