#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <tuple>
#include <iomanip>
#include <string>
#include <cmath>
using namespace std;
vector<vector<int>>graph(1e5 + 1);
vector<int>vis;
void dfs(int start, int last){
    vis[start] = min(start, vis[last]);
    for(auto val: graph[start]){
        if(vis[val] == 1e9){
            dfs(val, start);
        }
    }
}
int main() {
    vis.resize(1e5 + 1, 1e9);
    for(int i = 1; i < 1e5 + 1; i++){
        int maximum = 1;
        for(int j = 2; j * j <= i; j++){
            if(i % j == 0) maximum = max(maximum, i / j);
        }
        if(maximum != i){
            graph[i].push_back(maximum);
            graph[maximum].push_back(i);
        }
    }
    for(int i = 1; i < 1e5 + 1; i++){
        if(vis[i] == 1e9) dfs(i, i);
    }
    int n;
    cin >> n;
    for(int i = 0; i < n; i++){
        int a, b;
        cin >> a >> b;
        if(a == b) cout << a << "\n";
        else if(vis[a] == vis[b]){
            cout << vis[a] << "\n";
        }
        else{
            cout << -1 << "\n";
        }
    }
}