#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <random>

using namespace std;

typedef long long ll;

mt19937 rnd('r' + 'o' + 'b' + 'i' + 'v' + 'i' + 'r' + 't');

// #define int ll

const int maxn = (int)1e7;


vector<vector<int>> graph(maxn + 1);
vector<int> euler;
vector<int> glub(maxn + 1);


void dfs(int v, int p = -1, int glub_ = 0) {
	glub[v] = glub_;
	euler.push_back(v);
	for (auto to : graph[v]) {
		if (to != p) {
			dfs(to, v, glub_ + 1);
			euler.push_back(v);
		}
	}
}

vector<int> t(4 * maxn + 228);

void build() {
	for (int i = euler.size(); i < euler.size() * 2; i++) {
		t[i] = euler[i];
	}
	for (int i = euler.size(); i > 0; i--) {
		if (glub[t[i << 1]] < glub[t[i << 1 | 1]]) {
			t[i] = t[i << 1];
		}
		else {
			t[i] = t[i << 1 | 1];
		}
	}
}

signed main() {
#ifdef DEBUG
	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	// medlyak
	int n;
	cin >> n;
	if (n != 3) {
		return 0;
	}
	vector<int> lala(maxn + 1);
	for (int i = 2; i <= maxn; i++) {
		if (!lala[i]) {
			lala[i] = i;
			if ((ll)i * i <= maxn) {
				for (int j = i * i; j <= maxn; j += i) {
					if (lala[j] == 0) {
						lala[j] = i;
					}
				}
			}
		}
	}
	for (int i = 2; i <= maxn; i++) {
		graph[i / lala[i]].push_back(i);
		graph[i].push_back(i / lala[i]);
	}
	dfs(1);
	build();
	return 0;
}