#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <deque>
#include <cmath>
#include <cassert>
#include <queue>

using namespace std;
typedef long long ll;

int n, m;
pair <int, int> a[100010][2];

vector <pair <int, int>> b;
int dp[100010][2];

int cnt(int l, int r)
{
	int ans = 0;
	for (auto i : b)
	{
		ans += l <= i.first && i.second <= r;
	}
	return ans;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> m;
	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i][0].first >> a[i][0].second >> a[i][1].first >> a[i][1].second;
	}
	++n;
	a[n][0] = { 1e9 + 10, 1e9 + 10 };
	a[n][1] = { 1e9 + 20, 1e9 + 20 };

	b.resize(m);
	for (int j = 0; j < m; ++j)
	{
		cin >> b[j].first >> b[j].second;
	}

	for (int i = 1; i <= n; ++i)
	{
		for (int j = 0; j < 2; ++j)
		{
			for (int k = 0; k < 2; ++k)
			{
				dp[i][j] = max(dp[i][j], dp[i - 1][k] + cnt(a[i - 1][k].second + 1, a[i][j].first - 1));
			}
		}
	}

	cout << dp[n][0];
	return 0;
}