#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <deque>
#include <cmath>
#include <cassert>
#include <queue>

using namespace std;
typedef long long ll;
#define int long long 

int n, m, q;

vector <pair <int, signed>> a;

const int inf = 1e9;
int mini = inf;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> m >> q;
	a.push_back({ 0, 0 });

	for (int i = 1; i <= q; ++i)
	{
		int l, r;
		cin >> l >> r;
		--l; --r;

		int len = r - l + 1;

		if (len <= m && l % m <= r % m)
		{
			a.push_back({ l % m, 1 });
			a.push_back({ r % m + 1, -1 });
		}
		else
		{
			a.push_back({ l % m, 1 });
			a.push_back({ 0, 1 });
			a.push_back({ r % m - 1, -1 });
			len -= m - l % m;
			len -= r % m + 1;
			a.push_back({ 0, len / m });
		}
	}

	sort(a.begin(), a.end());
	vector <pair <int, int>> b;
	for (auto& i : a)
	{
		if (b.empty() || b.back().first != i.first)
		{
			b.push_back(i);
		}
		else
		{
			b.back().second += i.second;
		}
	}


	int sum = 0;
	for (auto i : b)
	{
		sum += i.second;
		if (i.first < m) mini = min(mini, sum);

	}

	cout << mini;
	return 0;
}