#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <queue>
#include <random>
#include <bitset>
#include <algorithm>

#define ll long long
#define ld long double
#define ll int

using namespace std;

mt19937 rnd;

int gcd(int a, int b) {
    if (a == 0) return b;
    if (b == 0) return a;
    return gcd(b, a % b);
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    
    vector<int>max_p(1e7 + 1, 0);
    for (int i = 2; i < 1e7 + 1; ++i) {
        if (!max_p[i]) {
            for (int j = i; j < 1e7 + 1; j += i) {
                if (!max_p[j]) max_p[j] = i;
            }
        }
    }
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        while (a != b) {
            if (a > b) swap(a, b);
            b /= max_p[b];
        }
        cout << a << '\n';
    }
    return 0;
}
