#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define sz(v) (int)v.size()
#define fastio ios_base::sync_with_stdio(false); cin.tie(NULL)

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

template<class T>
bool ckmin(T &a, const T &b) {
    if (b < a) {
        a = b;
        return true;
    }

    return false;
}

template<class T>
bool ckmax(T &a, const T &b) {
    if (b > a) {
        a = b;
        return true;
    }

    return false;
}

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const signed N = signed(1e5) + 100, MAXLOG = 20;

void solve() {
    int a, b; cin >> a >> b;
    vector<int> waya, wayb;

    while (a > 1) {
        waya.push_back(a);
        bool any = false;

        for (int i = 2; i * i <= a; ++i) {
            if (a % i == 0) {
                int f = i, s = a / i;
                a = s;
                any = true;
                break;
            }
        }

        if (!any) break;
    }

    waya.push_back(1);

    while (b > 1) {
        wayb.push_back(b);
        bool any = false;

        for (int i = 2; i * i <= b; ++i) {
            if (b % i == 0) {
                int f = i, s = b / i;
                b = s;
                any = true;
                break;
            }
        }

        if (!any) break;
    }

    wayb.push_back(1);

    sort(waya.begin(), waya.end());
    sort(wayb.begin(), wayb.end());

    for (int i = sz(waya) - 1; i >= 0; --i) {
        int x = waya[i];

        if (binary_search(wayb.begin(), wayb.end(), x)) {
            cout << x << "\n";
            return;
        }
    }
}

signed main() {
    fastio;

    int t; cin >> t;
    while (t--) solve();

    return 0;
}