#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

struct point {
    long long num;
    int flag;
};


int main() {
    long long n, m; cin >> n >> m; 
    int q ; cin >> q;
    map <long long, long long> info;
    set <long long> val;
    info[0] = 0;
    info[m] = 0;
    val.insert(0);
    val.insert(m);
    for (int i = 0; i < q; i ++) {
        long long L, R; cin >> L >> R;
        L --; R --;
        long long a = L / m;
        long long b = R / m;
        long long x = L % m;
        long long y = R % m;
        if (a == b) {
            if (val.find(x) == val.end()){
                info[x] = 0;
                val.insert(x);
            }
            if (val.find(y + 1) == val.end()){
                info[y + 1] = 0;
                val.insert(y + 1);
            }
            info[x] += 1;
            info[y + 1] -= 1;
        } else {
            if (val.find(x) == val.end()){
                info[x] = 0;
                val.insert(x);
            }
            if (val.find(y + 1) == val.end()){
                info[y + 1] = 0;
                val.insert(y + 1);
            }
            info[x] += 1;
            info[m] -= 1;
            info[0] += 1;
            info[y + 1] -= 1;
            info[0] += b - a - 1;
            info[m] -= b - a - 1;
        }
    }
    long long now = 0;
    long long worst = n;
    for (set <long long> :: iterator it = val.begin(); it != val.end(); it ++) {
        if (*it == m) {
            break;
        }
        now += info[*it];
        worst = min(worst, now);
    }
    cout << worst;
}