#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
const int N = 1000000;
vector<long long> g[N];
bool used[N];
bool used1[N];
vector<long long> put;
void bin(vector<long long> p) {
	long long l = -1, r = p.size() + 1, m, a;
	while (r - 1 > l) {
		m = (l + r) / 2;
		cout << p[m] << "\n"; fflush(stdout);
		cin >> a;
		if (a == 0) {
			cout << "! " << p[m] << "\n";
			return;
		}
		else {
			if (a == p[m + 1]) {
				l = m;
			}
			else {
				r = m;
			}
		}
	}
}
void dfs1(long long v) {
	used1[v] = true;
	for (auto i : g[v]) {
		if (used[i] == true and used1[i] == false and g[i].size() > 2) {
			put.push_back(i);
		}
		else if (used[i] == true and used1[i] == false) {
			put.push_back(i);
			dfs1(i);
		}
	}
	return;
}

void dfs(long long v) {
	used[v] = true;
	long long a, now = 0;
	for (auto i : g[v]) {
		if (used[i] == false) {
			now++;
			a = i;
		}
	}
	if (now == 1) {
		dfs(a);
	}
	else {
		cout << v << "\n"; fflush(stdout);
		cin >> a;
		if (a == 0){
			cout << "! " << v << "\n"; fflush(stdout);
		}
		else {
			if (used[a] == false) {
				dfs(a);
			}
			else {
				put.push_back(v);
				dfs1(v);
			}
		}
	}
}

int main() {
	long long n, a, b;
	cin >> n;
	for (int i = 0; i < n - 1; i++) {
		cin >> a >> b;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	dfs(1);
	bin(put);
	return 0;
}