#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define all(x) (x).begin(), (x).end()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template <typename T>
inline int len(const T& x) {
    return x.size();
}

const int inf = 1e9 + 9;
const ll llinf = 1e18 + 9;
const ll MOD = 1e9 + 7;
const int maxN = 2e5 + 9;
vector<int> fact(int n) {
    vector<int> res;
    for(int d = 2; d * d <= n; ++d) {
        while(n % d == 0) {
            res.pb(d);
            n /= d;
        }
    }
    if(n > 1) res.pb(n);
    return res;
}
void solve() {
    int a, b; cin >> a >> b;
    auto fa = fact(a), fb = fact(b);
    int ans = 1;
    for(int i = 0; i < len(fa) && i < len(fb); ++i) {
        if(fa[len(fa) - 1 - i] != fb[len(fb) - 1 - i]) break;
        ans *= fa[len(fa) - 1 - i];
    }
    cout << ans << '\n';
}
int main() {

    cin.tie(); cout.tie(0); ios_base::sync_with_stdio(0);
    int tc; cin >> tc;
    while(tc--) solve();
}
