#include<bits/stdc++.h>
using namespace std;
const int INF = 1e9;
int n;
vector<vector<int>> g;
vector<int> dist;

void print(vector<int> a) {
    for (auto i : a) cout << i << " ";
    cout << "\n";
}

void print(vector<vector<int>> a) {
    cout << "m\n";
    for (auto i : a) print(i);
    cout << "m\n";
}

void dfs(int v, int c) {
    dist[v] = c;
    for (auto i : g[v]) {
        if (dist[i] == -1) dfs(i, c + 1);
    }
}

int p(int v) {
    dist.clear();
    dist.resize(n, -1);
    dfs(v, 0);
    int pos = -1, mx = -1;
    for (int i = 0; i < n; i++) {
        if (mx < dist[i]) {
            mx = dist[i];
            pos = i;
        }
    }
    //print(dist);
    dist.clear();
    dist.resize(n, -1);
    dfs(pos, 0);
    //print(dist);
    mx = -1;
    for (int i = 0; i < n; i++) {
        mx = max(mx, dist[i]);
    }
    pos = -1;
    for (int i = 0; i < n; i++) {
        if (dist[i] == (mx + 1) / 2) {pos = i; break;}
    }
    return pos;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin >> n;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    int last = 0;
    while (true) {
        int pos = p(last), v;
        //cout << last << "n\n";
        cout << pos + 1 << endl;
        cin >> v;
        if (v == 0) {
            cout << "! " << pos + 1 << endl;
            break;
        }
        g[pos].clear();
        g[pos] = {v - 1};
        last = v - 1;
        //print(g);
    }
}
