#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <cmath>
#include <cstdlib>

using namespace std;
#define int long long
//#pragma GCC optimize("O3")

int readi() {
    int x = 0;
    char c;
    c = getchar();
    bool m = false;
    if (c == '-') {
        m = true;
    }
    else {
        x = c - '0';
    }
    while ((c = getchar()) >= '0' && c <= '9') {
        x = x * 10 + (c - '0');
    }
    if (m) return -x;
    return x;
}

void outpi(int v) {
    if (v < 0) {
        putchar('-');
        v = -v;
    }
    if (v == 0) {
        putchar('0');
        return;
    }
    char buf[20];
    int l = 0;
    while (v) {
        buf[l++] = v % 10 + '0';
        v /= 10;
    }
    for (int i = l - 1; i >= 0; i--) putchar(buf[i]);
}

int n;
vector<vector<int>> go;
vector<int> sz;
int totalsz = 0;
int mncentv = 1e9;
int mncenti = -100;

void calcsz(int cr, int fr = -1) {
    sz[cr] = 1;
    for (int to : go[cr]) {
        if (to == fr) continue;
        calcsz(to, cr);
        sz[cr] += sz[to];
    }
    totalsz = sz[cr];
}

void getcent(int cr, int fr = -1) {
    int mxv = totalsz - sz[cr];
    for (int to : go[cr]) {
        if (to == fr) continue;
        getcent(to, cr);
        mxv = max(mxv, sz[to]);
    }
    if (mxv < mncentv) {
        mncentv = mxv;
        mncenti = cr;
    }
}

signed main() {
    cin >> n;
    go.resize(n);
    sz.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        go[a].push_back(b);
        go[b].push_back(a);
    }
    int root = 0;
    while (true) {
        totalsz = 0;
        mncentv = 1e9;
        mncenti = -100;
        calcsz(root);
        getcent(root);
        cout << mncenti + 1 << endl;
        int v;
        cin >> v;
        if (v == 0) {
            cout << "! " << mncenti + 1 << endl;
            return 0;
        }
        else {
            v--;
            root = v;
            auto it = go[v].begin();
            while (it != go[v].end()) {
                if ((*it) == mncenti) {
                    go[v].erase(it);
                    break;
                }
                it++;
            }
        }
    }
    return 0;
}
