#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <cmath>
#include <cstdlib>

using namespace std;
#define int long long
//#pragma GCC optimize("O3")

int readi() {
    int x = 0;
    char c;
    c = getchar();
    bool m = false;
    if (c == '-') {
        m = true;
    }
    else {
        x = c - '0';
    }
    while ((c = getchar()) >= '0' && c <= '9') {
        x = x * 10 + (c - '0');
    }
    if (m) return -x;
    return x;
}

void outpi(int v) {
    if (v < 0) {
        putchar('-');
        v = -v;
    }
    if (v == 0) {
        putchar('0');
        return;
    }
    char buf[20];
    int l = 0;
    while (v) {
        buf[l++] = v % 10 + '0';
        v /= 10;
    }
    for (int i = l - 1; i >= 0; i--) putchar(buf[i]);
}

int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        if (a > b) {
            a %= b;
        }
        else {
            b %= a;
        }
    }
    return max(a, b);
}

void fct(int a, vector<int>& res) {
    int br = a;
    for (int i = 2; i * i <= br; i++) {
        while (a % i == 0) {
            a /= i;
            res.push_back(i);
        }
    }
    if (a != 1)
        res.push_back(a);
}

signed main() {
    int q = readi();
    while (q--) {
        int a = readi();
        int b = readi();
        if (a == b) {
            outpi(a);
            putchar('\n');
            continue;
        }
        int g = gcd(a, b);
        vector<int> add, rem;
        fct(a / g, rem);
        fct(b / g, add);
        int mx = 0;
        for (int i : rem) mx = max(mx, i);
        for (int i : add) mx = max(mx, i);
        int br = a;
        for (int i = 2; i < mx && i * i <= br; i++) {
            while (a % i == 0) {
                a /= i;
            }
        }
        outpi(a);
        putchar('\n');
        continue;
    }
    return 0;
}
