#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

struct ekz{
    int fl, fr, sl, sr;
};

int dpvals[3][100010];
int dp[2][100010];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<ekz> a;
    a.resize(n);
    for(int i = 0; i < n; ++i){
        cin >> a[i].fl >> a[i].fr >> a[i].sl >> a[i].sr;
    }
    int y = 0, l, r;
    int ans = 0;
    for (int i = 0; i < m; ++i) {
        cin >> l >> r;
        while (y != a.size() && l > a[y].sr) {
            ++y;
        }
        if (y == a.size()) {
            ++ans;
            continue;
        }
        if(a[y].fl > r || a[y].fr < l && a[y].sl > r){
            ++ans;
            continue;
        }
        if (a[y].fr >= l && a[y].sl <= r) {
            continue;
        }
        if (y + 1 < a.size()) {
            if (a[y + 1].sl <= r) {
                continue;
            }
        }
        if (a[y].sl > r) {
            ++dpvals[0][y];
            continue;
        }
        if (y + 1 < a.size()) {
            if (a[y + 1].fl <= r)
                ++dpvals[2][y + 1];
            else if (a[y].sl <= r || a[y].sr >= l)
                ++dpvals[1][y];
        }
        else {
            if (a[y].sl <= r || a[y].sr >= l)
                ++dpvals[1][y];
        }
    }
    //for (int i = 0; i < n; ++i) {
    //    cout << dpvals[0][i] << ' ' << dpvals[1][i] << ' ' << dpvals[2][i] << endl;
    //}
    for (int i = 0; i < n; ++i) {
        dp[0][i + 1] = max(dpvals[2][i] + dp[1][i], dp[0][i]) +dpvals[0][i];
        dp[1][i + 1] = max(dp[1][i], dp[0][i]) + dpvals[1][i];
    }
    cout << max(dp[0][n], dp[1][n]) + ans;
}
