#pragma optimization ("Ofast")
#pragma target ("avx2")

#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, a, b;
    vector<int> facta, factb;
    int as, bs;
    facta.resize(25);
    factb.resize(25);
    cin >> n;
    for(int i = 0; i < n; ++i){
        cin >> a >> b;
        as = 0;
        bs = 0;
        for(int i = 2; i <= sqrt(a)+2; ++i){
            while (a % i == 0){
                facta[as] = i;
                ++as;
                a /= i;
            }
        }
        if(a != 1){
            facta[as] = a;
            ++as;
        }
        for(int i = 2; i <= sqrt(b)+2; ++i){
            while (b % i == 0){
                factb[bs] = i;
                ++bs;
                b /= i;
            }
        }
        if(b != 1){
            factb[bs] = b;
            ++bs;
        }
        int ymod = -1;
        int ans = 1;
        while(min(as, bs) >= -ymod && facta[as+ymod] == factb[bs+ymod]){
            ans *= facta[as+ymod];
            --ymod;
        }
        cout << ans << '\n';
    }
}
