//#define _GLIBCXX_DEBUG 1

//#pragma GCC optimize("Ofast")
//#pragma GCC target("popcnt")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx,fma")


#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <deque>
#include <functional>
#include <set>
#include <map>
#include <random>
#include <memory>
#include <cassert>
#include <fstream>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <ctime>
#include <stack>
#include <queue>
#include <complex>
#include <chrono>
//#include <ext/pb_ds/detail/standard_policies.hpp>
//#include <ext/pb_ds/assoc_container.hpp>
//using namespace __gnu_pbds;


using namespace std;
using ll = long long;
using ul = unsigned long long;
using ld = long double;

template<typename T>
void print(T h, string s = " ") { for (auto ijkl : h) cout << ijkl << s; cout << "\n"; }

const long double EPS = 1e-8;
const long long INF = 2.5e18;
//#define int long long
#define vll vector <ll>
#define ve vector
#define sll set <ll>
#define hl pair <ll, ll>
#define printvhl(h) for (auto ijkl : h) cerr << ijkl.ft << ":" << ijkl.sd << " "; cerr << "\n";
#define scan(h, n) for (int ijkl = 0; ijkl < n; ++ijkl) cin >> h[ijkl]
#define pow2(n) ((n) * (n))
#define pow3(n) ((n) * (n) * (n))
#define all(x) (x).begin(), (x).end()
#define MOD ll(1000000007)
#define MOD2 ll(998244353)
#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front
#define ft first
#define sd second
#define look1(x)          cerr << #x << ": " << (x) << "\n";
#define look2(x, y)       cerr << #x << ": " << (x) << " | " << #y << ": " << (y) << "\n";
#define look3(x, y, z)    cerr << #x << ": " << (x) << " | " << #y << ": " << (y) << " | " << #z << ": " << (z) << "\n";
#define look4(a, b, c, d) cerr << #a << ":" << (a) << " | " << #b << ":" << (b) << " | " << #c << ":" << (c) << " | " << #d << ":" << (d) << "\n";

ll pown(ll n, ll cnt, ll mod = INT64_MAX) {
	return cnt == 0 ? 1 % mod : (cnt % 2 ? pown(n * n % mod, cnt / 2, mod) * n % mod : pown(n * n % mod, cnt / 2, mod) % mod);
}

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
char alph[] = "abcdefghijklmnopqrstuvwxyz0123456789";

pair <int, int> get_ex(int n) {
	return { n / 2, n % 2 };
}

map <pair <int, int>, int> get_cnt;


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int n, m;
	cin >> n >> m;
	ve<pair <pair <int, int>, pair <int, int> > > g;
	ve<pair <int, int> > alldays;
	ve<int> days;
	for (int i = 0; i < n; ++i) {
		int fl, fr, sl, sr;
		cin >> fl >> fr >> sl >> sr;
		g.pb({ {fl, fr}, {sl, sr} });
		alldays.push_back({ fl, fr });
		alldays.push_back({ sl, sr });
		days.push_back(fl);
		days.push_back(fr);
		days.push_back(sl);
		days.push_back(sr);
	}
	int ans = 0;
	for (int i = 0; i < m; ++i) {
		int l, r;
		cin >> l >> r;
		int ind1 = lower_bound(all(days), l) - days.begin();
		int ind2 = upper_bound(all(days), r) - days.begin() - 1;
		if (ind2 == -1) {
			++ans;
			continue;
		}
		pair <int, int> d1 = get_ex(ind1);
		pair <int, int> d2 = get_ex(ind2);
		if (d1.ft > d2.ft) ++ans;
		if (d1.ft == d2.ft) ++get_cnt[{d1.ft, d2.ft}];
		if (d2.ft == d1.ft + 1) {
			if (d1.ft % 2) {
				++get_cnt[{d1.ft, d2.ft}];
			}
		}
	}
	ve<ve<int> > dp(n + 1, ve<int>(2, 0));
	for (int i = 0; i < n; ++i) {
		dp[i + 1][0] = max(dp[i][0], dp[i][1]) + get_cnt[{i * 2 + 1, i * 2 + 1}];
		dp[i + 1][1] = max(dp[i][0] + get_cnt[{i * 2, i * 2}] + get_cnt[{i * 2 - 1, i * 2}], dp[i][1] + get_cnt[{i * 2, i * 2}]);
	}
	cout << ans + max(dp[n][0], dp[n][1]);
	return 0;
}