#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <unordered_map>
#define int long long
using namespace std;


void speed_fun(){
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}

unordered_map<int, set<int>> edge;
vector<int> check, check2;
int len_gr = 0, n = 0;

int len(int x){
    check2[x] = 1;
    int sum = 1;
    for (int i : edge[x]){
        if (check2[i])
            continue;
        sum += len(i);
    }
    return sum;
}

int dfs(int x, unordered_map<int, unordered_map<int, int>> & w){
    check[x] = 1;
    int sum = 0;
    for (int i : edge[x]){
        if (check[i])
            continue;
        w[x][i] = dfs(i, w) + 1;
        w[i][x] = len_gr - w[x][i];
        sum += w[x][i];
    }
    return sum;
}

int v(int x, unordered_map<int, unordered_map<int, int>> & w){
    for (int i : edge[x]){
        if (w[x][i] > len_gr / 2)
            return v(i, w);
    }
    return x;
}

void build(int x){
    unordered_map<int, unordered_map<int, int>> w;
    check.resize(0); check.resize(n + 1);
    check2.resize(0); check2.resize(n + 1);
    len_gr = len(x);
    dfs(x, w);
    x = v(x, w);
    cout << x << endl;
    int nx;
    cin >> nx;
    if (0 == nx){
        cout << "! " << x;
        return;
    }
    fflush(stdout);
    edge[nx].erase(x);
    build(nx);
}

signed main() {
    cin >> n;
    for (int i = 0; i < n - 1; i++){
        int a, b; cin >> a >> b;
        edge[a].insert(b);
        edge[b].insert(a);
    }
    build(1);
}
