#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <map>

using namespace std;

int main() {
    int N = 1e7;
    vector<int> lp(N + 1);
    vector<int> pr;
    for (int i = 2; i <= N; i++) {
        if (lp[i] == 0) {
            lp[i] = i;
            pr.push_back(i);
        }
        for (int j = 0; j < (int)pr.size() && pr[j] <= lp[i] && i * pr[j] <= N; j++)
            lp[i * pr[j]] = pr[j];
    }
    int t; cin >> t;
    while (t--) {
        int a, b; cin >> a >> b;
        map<int, int> um1, um2, um;
        int a1 = a, b1 = b;
        while (a1 > 1) {
            um1[lp[a1]]++;
            a1 /= lp[a1];
        }
        while (b1 > 1) {
            um2[lp[b1]]++;
            b1 /= lp[b1];
        }
        for (pair<int, int> x : um1)
            um[x.first] = x.second;
        for (pair<int, int> x : um2)
            um[x.first] = min(um[x.first], x.second);
        bool flag = 0;
        for (pair<int, int> x : um) {
            while (um1[x.first] > x.second) {
                um1[x.first]--;
                a /= x.first;
            }
            while (um2[x.first] > x.second) {
                um2[x.first]--;
                b /= x.first;
            }
            if (a == b) {
                cout << a << "\n";
                flag = 1;
                break;
            }
            while (um1[x.first] > 0) {
                um1[x.first]--;
                a /= x.first;
            }
            while (um2[x.first] > 0) {
                um2[x.first]--;
                b /= x.first;
            }
        }
        if (!flag)
            cout << "1\n";
    }
    return 0;
}