#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <map>

using namespace std;

void dfs(int v, int p, int lvl, vector<vector<int>>& g, vector<int>& h, vector<vector<int>>& dp) {
    h[v] = lvl;
    dp[v][0] = p;
    for (int u : g[v]) {
        if (u == p)
            continue;
        dfs(u, v, lvl + 1, g, h, dp);
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, q; cin >> n >> m >> q;
    vector<pair<int, int>> ot(n);
    vector<int> ans(m, 0);
    for (int i = 0; i < n; i++)
        cin >> ot[i].first >> ot[i].second;
    for (int i = 0; i < n; i++) {
        for (int j = ot[i].first; j <= ot[i].second; j++) {
            ans[(j - 1) % m]++;
        }
    }
    int answ = INT_MAX;
    for (int i = 0; i < m; i++)
        answ = min(answ, ans[i]);
    cout << answ;
    return 0;
}