#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
#define len(v) (int)(v).size()
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

vector<int> know;

vector<vector<int>> g;
vector<int> sz;
int n;
int total = 0;

void dfs_s(int u, int p) {
    sz[u] = 1;
    total++;
    for (auto &to : g[u]) {
        if (to != p) {
            dfs_s(to, u);
            sz[u] += sz[to];
        }
    }
}

int centroid;


void fnd(int u, int p) {
    int mx = 0;
    for (auto &to : g[u]) {
        if (to != p) {
            mx = max(mx, sz[to]);
            fnd(to, u);
        }
    }
    mx = max(mx, total - sz[u]);
    if (mx <= (total + 1) / 2) {
        centroid = u;
    }
}

int ask(int x) {
    if (know[x] != -1) return know[x];
    cout << x << endl;
    int a;
    cin >> a;
    return a;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    g.resize(n + 1);
    sz.resize(n + 1);
    know.resize(n + 1, -1);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].emplace_back(v);
        g[v].emplace_back(u);
    }
    int go = 1;
    int p = -1;
    int c = 21;
    while (c--) {
        dfs_s(go, p);
        fnd(go, p);
        go = ask(centroid);
        p = centroid;
        if (!go) {
            cout<<"! " << centroid << endl;
            return 0;
        }
        fill(all(sz), 0);
        total = 0;
    }
    cout << "! " << centroid << endl;
    return 0;
}