#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>
#include <unordered_set>
#include <string>

using namespace std;

int ask_hm(vector<pair<int, int>>& a, int l, int r) {
    int ans = 0;
    for (auto i: a) {
        if (l <= i.first && i.second <= r) {
            ans += 1;
        }
    }
    return ans;
}

int ask_hm1 (vector<pair<int, int>>& a, int l, int r) {
    return upper_bound(a.begin(), a.end(), make_pair(r, r)) - lower_bound(a.begin(), a.end(), make_pair(l, l));
}

int main() {
    int n, m;
    cin >> n >> m;

    vector<pair<pair<int, int>, pair<int, int>>> b;
    vector<pair<int, int>> tr;
    int ll = 0, rr = 0;
    for (int i = 0; i < n; ++i) {
        int l1, r1, l2, r2;
        cin >> l1 >> r1 >> l2 >> r2;
        b.push_back({{l1, r1}, {l2, r2}});
    }
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        tr.push_back({l, r});
    }
    if (n <= 1000 && m <= 1000) {
    int dp[n][2];
    for (int i = 0; i < n; ++i) {
        dp[i][0] = 100000;
        dp[i][1] = 100000;
    }
    dp[0][0] = ask_hm(tr, -100, b[0].first.first - 1);
    dp[0][1] = ask_hm(tr, -100, b[0].second.first - 1);
    for (int i = 0; i < n - 1; ++i) {
        dp[i + 1][0] = max(dp[i][0] + ask_hm(tr, b[i].first.second + 1, b[i + 1].first.first - 1), dp[i][1] + ask_hm(tr, b[i].second.second + 1, b[i + 1].first.first - 1));
        dp[i + 1][1] = max(dp[i][0] + ask_hm(tr, b[i].first.second + 1, b[i + 1].second.first - 1), dp[i][1] + ask_hm(tr, b[i].second.second + 1, b[i + 1].second.first - 1));
    }
    dp[n - 1][1] += ask_hm(tr, b[n - 1].second.second + 1, 1000000010);
    dp[n - 1][0] += ask_hm(tr, b[n - 1].first.second + 1, 1000000010);
    /*for (int i = 0; i < n; ++i) {
        cout << dp[i][0] << " ";
    }
    cout << "\n";
    for (int i = 0; i < n; ++i)
        cout << dp[i][1] << " ";
    cout << "\n";*/
    cout << max(dp[n - 1][1], dp[n - 1][0]);
    } else {
    sort(tr.begin(), tr.end());
    int dp[n][2];
    for (int i = 0; i < n; ++i) {
        dp[i][0] = 100000;
        dp[i][1] = 100000;
    }
    dp[0][0] = ask_hm1(tr, -100, b[0].first.first - 1);
    dp[0][1] = ask_hm1(tr, -100, b[0].second.first - 1);
    for (int i = 0; i < n - 1; ++i) {
        dp[i + 1][0] = max(dp[i][0] + ask_hm1(tr, b[i].first.second + 1, b[i + 1].first.first - 1), dp[i][1] + ask_hm1(tr, b[i].second.second + 1, b[i + 1].first.first - 1));
        dp[i + 1][1] = max(dp[i][0] + ask_hm1(tr, b[i].first.second + 1, b[i + 1].second.first - 1), dp[i][1] + ask_hm1(tr, b[i].second.second + 1, b[i + 1].second.first - 1));
    }
    dp[n - 1][1] += ask_hm1(tr, b[n - 1].second.second + 1, 1000000010);
    dp[n - 1][0] += ask_hm1(tr, b[n - 1].first.second + 1, 1000000010);
    /*for (int i = 0; i < n; ++i) {
        cout << dp[i][0] << " ";
    }
    cout << "\n";
    for (int i = 0; i < n; ++i)
        cout << dp[i][1] << " ";
    cout << "\n";*/
    cout << max(dp[n - 1][1], dp[n - 1][0]);
    }
}

