#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>
#include <map>
using namespace std;

struct graph {
    map<int, vector<int>> moves;
    vector<int> nod;
};
int fur = -1, dist = -1;
void dfs1(int a, int p, int d, graph& g) {
    if (d > dist) {
        fur = a;
        dist = d;
    }
    for (auto i: g.moves[a]) {
        if (i != p) {
            dfs1(i, a, d + 1, g);
        }
    }
}

vector<int> trail;
vector<int> nt;

void pdfs1(int a, int p, int d, graph& g) {
    if (a == d && !nt.size()) {
        nt = trail;
    }
    for (auto i: g.moves[a]) {
        if (i != p) {
            trail.push_back(i);
            pdfs1(i, a, d, g);
            trail.pop_back();
        }
    }
}
int furthest_p(int a, graph& g) {
    fur = -1;
    dist = -1;
    dfs1(a, -1, 0, g);
    return fur;
}

void remakedfs(int a, int p, graph& new_g, graph& g) {
    new_g.nod.push_back(a);
    for (auto i: g.moves[a]) {
        if (i != p) {
            new_g.moves[a].push_back(i);
            new_g.moves[i].push_back(a);
            remakedfs(i, a, new_g, g);
        }
    }
}
int ans = -1;
graph make_move(graph g) {
    for (auto i: g.nod)
        cout << "! " << i << "\n";
    cout << "\n";
    cout << "\n";
    if (g.nod.size() == 1) {
        return g;
        cout << g.nod[0];

        ans = (g.nod[0]);
    }
    int a = (g.nod)[0];
    int b = furthest_p(a, g);
    int c = furthest_p(b, g);
    int d = furthest_p(c, g);
    trail = {a};
    nt = {};
    pdfs1(c, -1, d, g);
    int pask = nt[nt.size() / 2];
    cout << pask << "\n";
    int mv;
    fflush(stdout);
    cin >> mv;
    if (mv == 0) {
        ans = pask;
        cout << "! " << pask << "\n";
        return g;
    }
    graph new_g;
    remakedfs(mv, pask, new_g, g);
    return make_move(new_g);
}

int main() {
    map<int, vector<int>> g1;
    vector<int> nod;
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i)
        nod.push_back(i);
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        g1[u].push_back(v);
        g1[v].push_back(u);
    }
    graph g = {g1, nod};
    make_move(g);
}
