#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>
#include <unordered_map>
using namespace std;

struct graph {
    vector<vector<int>> moves;
    vector<pair<int, int>> nod;
};
int fur = -1, dist = -1;
void dfs1(int a, int p, int d, graph& g) {
    if (d > dist) {
        fur = a;
        dist = d;
    }
    for (auto i: g.moves[a]) {
        if (i != p) {
            dfs1(i, a, d + 1, g);
        }
    }
}

vector<int> trail;
vector<int> nt;

void pdfs1(int a, int p, int d, graph& g) {
    if (a == d && !nt.size()) {
        nt = trail;
    }
    for (auto i: g.moves[a]) {
        if (i != p) {
            trail.push_back(i);
            pdfs1(i, a, d, g);
            trail.pop_back();
        }
    }
}
int furthest_p(int a, graph& g) {
    fur = -1;
    dist = -1;
    dfs1(a, -1, 0, g);
    return fur;
}
int t = 2;
vector<pair<int, int>> new_n;
void remakedfs(int a, int p, int n, graph& new_g, graph& g) {
    new_n.push_back({n, g.nod[a - 1].second});
    for (auto i: g.moves[a]) {
        if (i != p) {
            new_g.moves[n].push_back(t);
            new_g.moves.push_back({});
            new_g.moves[t].push_back(n);
            t += 1;
            remakedfs(i, a, t - 1, new_g, g);
        }
    }
}
int ans = -1;
graph g;
void make_move() {
    if (g.nod.size() == 1) {
        cout << "! " << g.nod[0].second << "\n";
        return;
    }
    int a = 1;
    int b = furthest_p(a, g);
    int c = furthest_p(b, g);
    trail = {b};
    nt = {};
    pdfs1(b, -1, c, g);
    int pask = g.nod[nt[nt.size() / 2] - 1].second;
    cout << pask << "\n";
    int mv;
    fflush(stdout);
    cin >> mv;
    if (mv == 0) {
        cout << "! " << pask << "\n";
        return;
    }
    graph new_g;
    new_g.moves.push_back({});
    new_g.moves.push_back({});
    t = 2;
    new_n.clear();
    remakedfs(mv, nt[nt.size() / 2], 1, new_g, g);
    new_g.nod = new_n;
    g = new_g;
    return make_move();
}

int main() {
    vector<vector<int>> g1;
    vector<pair<int, int>> nod;
    int n;
    cin >> n;
    g1.resize(n + 1);
    for (int i = 1; i <= n; ++i)
        nod.push_back({i, i});
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        g1[u].push_back(v);
        g1[v].push_back(u);
    }
    g = {g1, nod};
    make_move();
}
