#pragma GCC optimize("O3,unroll-loops,fast-math")
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <random>
using namespace std;
typedef long long ll;
const int INF = 1e9 + 7;
const ll LLINF = 2e18 + 13;
mt19937 rng;
uniform_int_distribution<int> uid(0, INF-1);
template<typename T>void smin(T&a,T b) {if(b<a)a=b;}
template<typename T>void smax(T&a,T b) {if(b>a)a=b;}

int32_t main() {
  ios_base::sync_with_stdio(0); cin.tie(0);

  int n, m;
  cin >> n >> m;
  vector<pair<int,int> > f(n), s(n);
  vector<vector<int> > poss(n, vector<int>(2));
  vector<bool> conn(n);
  set<pair<int,pair<int,int> > > ls, rs;
  for (int i = 0; i < n; ++i) {
    cin >> f[i].first >> f[i].second >> s[i].first >> s[i].second;
    ls.insert({f[i].first,{i,0}});
    ls.insert({s[i].first,{i,1}});
    rs.insert({f[i].second,{i,0}});
    rs.insert({s[i].second,{i,1}});
  }
  int additional = 0;
  for (int i = 0,l,r; i < m; ++i) {
    cin >> l >> r;
    auto rp = rs.lower_bound({l,{-1,-1}});
    auto lp = ls.lower_bound({r,{INF,-1}});
    if (lp == ls.begin()) {
      ++additional; continue;
    }
    --lp;
    if (rp == rs.end()) {
      ++additional; continue;
    }
    int re = rp->first, ri = rp->second.first, rt = rp->second.second;
    int le = lp->first, li = lp->second.first, lt = lp->second.second;
    if (re > le && (ri != li || rt != lt)) {
      ++additional;
      continue;
    }
    if ((ri == li && rt != lt) || (li - ri > 1 || (li - ri == 1 && !(rt == 1 && lt == 0)))) {
      continue;
    }
    if (ri == li) {
      poss[li][rt]++;
    } else {
      conn[ri] = true;
    }
  }
  vector<vector<int>> dp(n, vector<int>(2));
  dp[0][0] = poss[0][0];
  dp[0][1] = poss[0][1];
  for (int i = 1; i < n; ++i) {
    dp[i][0] = poss[i][0] + max(dp[i-1][0],dp[i-1][1]);
    dp[i][1] = poss[i][1] + max(dp[i-1][0] + conn[i-1], dp[i-1][1]);
  }
  cout << max(dp[n-1][0], dp[n-1][1]) + additional << endl;

  return 0;
}
