#include <iostream>
#include <vector>
#include <string>
#include <cassert>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#define int long long
using namespace std;
struct node {
    int mn = 0, pr = 0;
    int l = -1;
    int r = -1;
};

vector <node> tree;
int add() {
    int ind = tree.size();
    node nd;
    tree.push_back(nd);
    return ind;
}
void push(int v, int l, int r) {
    if (r - l == 1 || tree[v].pr==0) {
        tree[v].pr = 0;
        return;
    }
    if (tree[v].l == -1) {
        tree[v].l = add();
    }
    if (tree[v].r == -1) {
        tree[v].r = add();
    }
    tree[tree[v].l].mn += tree[v].pr;
    tree[tree[v].r].mn += tree[v].pr;
    tree[tree[v].l].pr += tree[v].pr;
    tree[tree[v].r].pr += tree[v].pr;
    tree[v].pr = 0;
}
void upd(int v, int l, int r, int ql, int qr, int x) {
    push(v, l, r);
    if (ql <= l && r <= qr) {
        tree[v].pr += x;
        tree[v].mn += x;
        return;
    }
    if (qr <= l || ql >= r) {
        return;
    }
    int mid = (r + l) / 2;
    if (tree[v].l == -1) {
        tree[v].l = add();
    }
    if (tree[v].r == -1) {
        tree[v].r = add();
    }
    upd(tree[v].l, l, mid, ql, qr, x);
    upd(tree[v].r, mid, r, ql, qr, x);
    tree[v].mn = min(tree[tree[v].l].mn, tree[tree[v].r].mn);
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, m, q;
    cin >> n >> m >> q;
    node st;
    tree.push_back(st);
    for (int i = 0; i < q; ++i) {
        int l, r;
        cin >> l >> r;
        if (r - l >= m) {
            int cnt = (r - l) / m;
            upd(0, 0, m, 0, m, cnt);
            

        }
        int nc = (l - 1) % m;
        int kc = (r - 1) % m;
        if (kc >= nc) {
            upd(0, 0, m, nc, kc + 1, 1);
        }
        else {
            upd(0, 0, m, 0, kc + 1, 1);
            upd(0, 0, m, nc, m, 1);
        }
        
    }
    cout << tree[0].mn;


}