#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("tune=native")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll N = 2e5, INF = 1e18;

vector<ll> G[N];
ll W[N];

ll query(ll v) {
    cout << v + 1 << endl;
    ll u;
    cin >> u;
    u--;
    return u;
}

ll g_count(ll v, ll w = -1) {
    ll s = 1;
    for (ll u : G[v]) if (u != w && !W[u]) s += g_count(u, v);
    return s;
}

void g_mark(ll v, ll w = -1) {
    W[v] = 1;
    for (ll u : G[v]) if (u != w && !W[u]) g_mark(u, v);
}

int main() {
#ifndef AVEVAD
    //cin.tie(0);
    //ios_base::sync_with_stdio(0);
#endif
    ll n;
    cin >> n;
    for (ll i = 0; i < n - 1; i++) {
        ll v, u;
        cin >> v >> u;
        v--, u--;
        G[v].push_back(u);
        G[u].push_back(v);
    }
    ll ans = -1;
    while (true) {
        ll min_v = -1, min_max = INF;
        for (ll v = 0; v < n; v++) {
            if (W[v]) continue;
            ll v_max = 0;
            for (ll u : G[v]) {
                if (W[v]) continue;
                v_max = max(v_max, g_count(u, v));
            }
            if (v_max < min_max) min_max = v_max, min_v = v;
        }
        ll u = query(min_v);
        if (u == -1) {
            ans = min_v;
            break;
        }
        g_mark(min_v, u);
    }
    cout << "! " << ans + 1 << endl;
}
/*
9
1 2
3 1
3 4
3 5
5 6
5 7
5 8
8 9
 */