#include<bits/stdc++.h>

#define int long long
#define f first
#define s second
#define vec vector
#define pb push_back
#define sz(x) (int)(x).size()
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define all(x) (x).begin(), (x).end()
#define ld long double
#define pii pair<int, int>

using namespace std;

signed main()
{
    int n;
    cin >> n;

    vec<vec<int>> g (n);
    FOR(i, n - 1)
    {
        int l, r;
        cin >> l >> r;
        l--; r--;

        g[l].pb(r);
        g[r].pb(l);
    }

    int its = 20;

    auto get = [&](int v)
    {
        assert(its);
        its--;
        cout << v << endl;
        int x;
        cin >> x;
        x--;
        if(x == -1)
        {
            cout << "! " << v << endl;
            exit(0);
        }
        return x;
    };

    int f = 0;

    FOR(i, n)
    {
        if(sz(g[i]) > 2)
            f = 1;
    }

    if(f)
    {
        FOR(i, n)
        {
            check(i + 1);
        }
        return 0;
    }

    int start = -1;

    FOR(i, n)
    {
        if(sz(g[i]) == 1)
            start = i;
    }

    vec<int> num (n);
    vec<int> revnum (n);
    int it = 0;

    function<void(int, int)> dfs = [&](int v, int p)
    {
        //cout << v << endl;
        num[it] = v;
        revnum[v] = it;
        it++;

        for(auto u : g[v])
        {
            if(u != p)
                dfs(u, v);
        }
    };

    dfs(start, -1);

//    for(auto i : num)
//        cout << i << ' ';
//    cout << endl;

    int l = 0, r = n - 1;

    while(r - l > 1)
    {
        int mid = l + r >> 1;

        int v = get(num[mid] + 1);

        if(revnum[v] < mid)
        {
            r = mid;
        }
        else
            l = mid;
    }

    int v = get(num[r] + 1);
    cout << "! " << num[l] + 1 << endl;
}

