#include<bits/stdc++.h>

#define int long long
#define f first
#define s second
#define vec vector
#define pb push_back
#define sz(x) (int)(x).size()
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define all(x) (x).begin(), (x).end()
#define ld long double
#define pii pair<int, int>

using namespace std;
const int MAXN = 1e5 + 22;
const int INF = 1e9;

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;

    vec<vec<int>> g (MAXN);
    for(int i = 2; i < MAXN; i++)
    {
        int mx = 1;
        for(int x = 2; x * x <= i; x++)
        {
            if(i % x == 0)
            {
                mx = i / x;
                break;
            }
        }

        g[i].pb(mx);
        g[mx].pb(i);
    }

    auto BFS = [&](int st, int fn)
    {
        queue<int> q;
        vec<int> d (MAXN, INF);
        vec<int> mn (MAXN, INF);
        d[st] = 0;
        mn[st] = st;
        q.push(st);

        while(sz(q))
        {
            int v = q.front();
            q.pop();

            for(auto u : g[v])
            {
                if(d[u] > d[v] + 1)
                {
                    d[u] = d[v] + 1;
                    mn[u] = min(u, mn[v]);
                    q.push(u);
                }
                if(d[u] == d[v] + 1)
                {
                    mn[u] = max(mn[u], min(u, mn[v]));
                }
            }
        }

        return mn[fn];
    };

    FOR(i, n)
    {
        int a, b;
        cin >> a >> b;

        int x = BFS(a, b);
        if(x == INF)
            cout << -1 << endl;
        else
            cout << x << endl;
    }
}


