#include <algorithm>
#include <iostream>
#include <map>
#include <vector>

long long n, m, q;

void increment(long long l, long long r, std::map<long long, long long>& a)
{
    ++a[l];
    if (r < m) --a[r];
}

int main()
{
    std::cin >> n >> m >> q;
    long long ans = 0;
    std::map<long long, long long> cnt;
    for (long long i = 0; i < q; ++i) {
	long long l, r;
	std::cin >> l >> r;
	--l, --r;
	if (l / m == r / m) {
	    increment(l % m, r % m + 1, cnt);
	} else {
	    increment(l % m, m, cnt);
	    increment(0, r % m + 1, cnt);
	    ans += (r / m) - (l / m) - 1;
	}
    }
    long long cur = 0;
    long long mn = n;
    for (auto& el: cnt) {
	cur += el.second;
	mn = std::min(mn, cur);
    }
    std::cout << ans + mn << '\n';
    return 0;
}

