#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <string>
#include <deque>
#include <algorithm>
#include <iomanip>
#include <unordered_map>
#include <cmath>

using namespace std;

typedef long long ll;
const ll inf = 1e9;
const ll mod = 1e9 + 7;



int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n;
	cin >> n;
	map<int, vector <int>> m;
	set <int> s;
	for (int i = 1; i != n + 1; i++)s.insert(i);
	if (n > 1e5) return 0; 
	for (int i = 0; i != n - 1; i++) {
		int a, b;
		cin >> a >> b;
		m[a].push_back(b);
		m[b].push_back(a);
		if (m[a].size() == 2) s.erase(a);
		if (m[b].size() == 2) s.erase(b);


	}
	if (n <= 20) {
		for (int i = 1; i != 21; i++) {
			cout << i << endl;
			string s;
			cin >> s;
			if (s == to_string(0)) {
				cout << "! " << i << endl;

				return 0;
			}
		}
	}
	vector <int> v(n);
	v[0] = *s.begin();
	v[1] = m[v[0]][0];
	for (int i = 1; i != n - 1; i++) {
		if (v[i - 1] == m[v[i]][0]) {
			v[i + 1] = m[v[i]][1];
		}
		else {
			v[i + 1] = m[v[i]][0];

		}
	}
	for (int i : v) if (i == 0) return 1;
	int r = n - 1, l = 0;
	while (r - l != 1) {
		int to = (r + l) / 2;
		cout << v[to] << endl;
		string s;
		cin >> s;
		if (s == to_string(0)) {
			cout << "! " << v[to] << endl;
			return 0;
		}
		if (to > 0 && s == to_string(v[to - 1])) {
			r = to;
		}
		else {
			l = to;
		}
	}
	cout << v[r] << endl;

	string s1;
	cin >> s1;
	if (s1 == to_string(0)) {
		cout << "! " << v[r] << endl;
		return 0;
	}
	else {
		cout << "! " << v[l] << endl;
		return 0;
	}
}