#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <string>
#include <deque>
#include <algorithm>
#include <iomanip>
#include <unordered_map>
#include <cmath>

using namespace std;

typedef long long ll;
const ll inf = 1e9;
const ll mod = 1e9 + 7;



int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t;
	cin >> t;
	while (t--) {
		int a, b;
		cin >> a >> b;
		int a1, b1;
		a1 = a;
		b1 = b;
		if (a == b) {
			cout << a << endl; continue;
		}
		vector< pair<int,int>> na, nb;
		for (int i = 2; i <= a; i++) {
			
			if (a % i == 0) {
				na.push_back({ i,0 });
			}
			while (a % i == 0) {
				a /= i;
				na[na.size() - 1].second++;

			}
			if (i > sqrt(a1) && a == a1) {
				na.push_back({ a,1 });
				break;
			}
		}
		for (int i = 2; i <= b; i++) {
			
			if (b % i == 0) {
				nb.push_back({ i,0 });
			}
			while (b % i == 0) {
				b /= i;
				nb[nb.size() - 1].second++;

			}
			if (i > sqrt(b1) && b == b1) {
				na.push_back({ b,1 });
				break;
			}
		}
		reverse(nb.begin(), nb.end());
		reverse(na.begin(), na.end());

		
		int ans = 1;
		int l = 0, r = 0;
		bool t = false;
		while (l != na.size() && r != nb.size()) {
			if (na[r] == nb[l]) {
				ans *= pow(na[r].first, na[r].second);
			}
			else if (na[r].first == nb[l].first) {

				if (min(na[r].second, nb[l].second) == na[r].second) t = true;
				ans *= pow(na[r].first, min(na[r].second, nb[l].second));
				break;

			}
			else {
				break;
			}

			l++;
			r++;
		}
		
		cout << ans << endl;
	}
}