#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <string>
#include <deque>
#include <algorithm>
#include <iomanip>
#include <unordered_map>
#include <cmath>

using namespace std;

typedef long long ll;
const ll inf = 1e9;



int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);

	int n, m, q;
	cin >> n >> m >> q;
	vector <int> v(m);
	for (int i = 0; i != q; i++) {
		int l, r;
		cin >> l >> r;
		l %= m;
		r %= m;
		if (l > r) swap(l, r);
		for (int w = l; w <= r; w++) v[w]++;
	}
	
	int ans = inf;
	for (int i : v) ans = min(ans, i);
	cout << ans;
}