#pragma comment(linker, "/STACK:130000000")
#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <queue>
#include <unordered_set>
#include <ctime>
#include <random>
using namespace std;

inline void start() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
}

const int N = 1e4;
vector<int> prime;
bool notPrime[N];

void f() {
	for (int i = 2; i < N; i++)
		if (!notPrime[i]) {
			prime.push_back(i);
			for (int j = i * i; j < N; j += i)
				notPrime[j] = 1;
		}
}

long long g(long long x, long long n) {
	return (x + 1) * (x + 1) % n;
}

long long gcd(long long a, long long b) {
	if (b == 0)
		return a;
	return gcd(b, a % b);
}

void o(long long x, vector<int>& v) {
	vector<int> t;
	for (int i = 0; i < 3; i++) {
		int a = rand();
		int b = a;
		for (int i = 0; i < 100; i++) {
			int y = abs(a - b);
			int d = gcd(y, x);
			if (d > 1 && d < x) {
				x /= d;
				t.push_back(d);
			}
			a = g(a, x);
			b = g(g(b, x), x);
		}
	}
	if (x > 1)
		t.push_back(x);
	for (int i : t) {
		int y = i;
		for(int j = 0; j < prime.size() && y > 1; j++)
			while (y % prime[i] == 0) {
				y /= prime[i];
				v.push_back(prime[i]);
			}
		if (y > 1)
			v.push_back(y);
	}
	sort(v.begin(), v.end());
}

int main() {
	start();
	srand(time(0));
	f();
	int t;
	cin >> t;
	while (t--) {
		int a, b;
		vector<int> va, vb;
		long long ans = 1;
		cin >> a >> b;
		o(a, va);
		o(b, vb);
		while (!va.empty() && !vb.empty() &&
			va.back() == vb.back()) {
			ans *= va.back();
			va.pop_back();
			vb.pop_back();
		}
		cout << ans << '\n';
	}
	return 0;
}