#include <bits/stdc++.h>
#define int long long
#ifdef LOCAL
#   define debug(x) cout << #x << " = " << (x) << endl
#else
#   define debug(x)
#endif

typedef long long ll;
typedef long double ld;
using namespace std;

const int maxn = 1e7 + 1;
int p[maxn];
vector<int> primes;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    for (int i = 2; i < maxn; i++) {
        if (p[i] == 0) {
            p[i] = i;
            primes.push_back(i);
        }
        for (int d : primes) {
            if (d <= p[i] && d * i < maxn) p[i * d] = d;
            else break;
        }
    }

    int t; cin >> t;
    while (t--) {
        int a, b; cin >> a >> b;

        vector<int> A;
        while (true) {
            A.push_back(a);
            if (a == 1) break;
            else a /= p[a];
        }

        vector<int> B;
        while (true) {
            B.push_back(b);
            if (b == 1) break;
            else b /= p[b];
        }
        reverse(A.begin(), A.end());
        reverse(B.begin(), B.end());

        vector<int> C;
        set_intersection(A.begin(), A.end(), B.begin(), B.end(), back_inserter(C));
        cout << C.back() << "\n";
    }
    return 0;
}