#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <deque>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e18;
const ld EPS = 1e-9;
const ll MOD = 1000000000 + 7;
const ld PI = acos(-1);

struct O {
	ll l, r;
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n, m, q;
	cin >> n >> m >> q;
	vector<ll> a = { 0, m };
	vector<O> b(q);
	for (ll i = 0; i < q; i++) {
		cin >> b[i].l >> b[i].r;
		b[i].l--;
		b[i].r--;
		a.push_back(b[i].l % m);
		a.push_back(b[i].r % m);
	}
	sort(a.begin(), a.end());
	vector<ll> a1 = { a[0] };
	for (ll i = 1; i < a.size(); i++) {
		if (a[i] != a[i - 1]) a1.push_back(a[i]);
	}
	a = a1;
	vector<ll> s(a.size() + 1);
	for (ll i = 0; i < q; i++) {
		ll l = b[i].l, r = b[i].r;
		ll l1 = upper_bound(a.begin(), a.end(), l % m) - a.begin();
		ll r1 = upper_bound(a.begin(), a.end(), r % m) - a.begin();
		if (l / m == r / m) {
			s[l1]++;
			s[r1 + 1]--;
		}
		else {
			ll k = r / m - l / m - 1;
			s[0] += k;
			s.back() -= k;
			s[l1]++;
			s.back()--;
			s[0]++;
			s[r1 + 1]--;
		}
	}
	ll mn = s[0];
	for (ll i = 1; i + 1 < s.size(); i++) {
		s[i] += s[i - 1];
		mn = min(mn, s[i]);
	}
	cout << mn << "\n";
	return 0;
}