#include <bits/stdc++.h>

#define int long long
using namespace std;

deque<int> f(int n) {
    if (n == 1) return {1};
    if (n == 2) return {2};
    int i = 2;
    deque<int> res;
    while (i * i <= n) {
        if (n % i == 0) {
            n /= i;
            res.push_back(i);
        } else {
            i++;
        }
    }
    if (n != 1) {
        res.push_back(n);
    }
    return res;
}


signed main() {
    int n;
    cin >> n;
    while (n--) {
        int a, b;
        cin >> a >> b;
        if (a > b) {
            swap(a, b);
        }
        deque<int> y = f(a);
        deque<int> u = f(b);
        int ans = 1;
        while (!y.empty() && !u.empty()) {
            if (y.back() == u.back()) {
                ans *= y.back();
                y.pop_back();
                u.pop_back();
            } else { break; }
        }
        cout << ans << '\n';
    }
}



















