#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <random>

using namespace std;

typedef long long ll;

mt19937 rnd('r' + 'o' + 'b' + 'i' + 'v' + 'i' + 'r' + 't');

// #define int ll

const int maxn = (int)1e7;

signed main() {
#ifdef DEBUG
	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	// medlyak
	
	vector<int> lala(maxn + 1);
	for (int i = 2; i <= maxn; i++) {
		if (!lala[i]) {
			lala[i] = i;
			if ((ll)i * i <= maxn) {
				for (int j = i * i; j <= maxn; j += i) {
					if (lala[j] == 0) {
						lala[j] = i;
					}
				}
			}
		}
	}
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		int a, b;
		cin >> a >> b;
		vector<int> aaa1, aaa2;
		int v = a;
		while (v != 1) {
			aaa1.push_back(lala[v]);
			v /= lala[v];
		}
		v = b;
		while (v != 1) {
			aaa2.push_back(lala[v]);
			v /= lala[v];
		}
		reverse(aaa1.begin(), aaa1.end());
		reverse(aaa2.begin(), aaa2.end());
		while (aaa1.size() < aaa2.size()) {
			aaa1.push_back(1);
		}
		while (aaa1.size() > aaa2.size()) {
			aaa2.push_back(1);
		}
		reverse(aaa1.begin(), aaa1.end());
		reverse(aaa2.begin(), aaa2.end());
		int ans = 1;
		for (int j = 0; j < aaa1.size() && aaa1[j] == aaa2[j]; j++) {
			ans *= aaa1[j];
		}
		cout << ans << '\n';
		
	}
	return 0;
}