#include <bits/stdc++.h>
#define int long long

using namespace std;


vector<vector<int>> g;
vector<int> h, mar;
vector<int> was;

void dfs(int u){
    for (auto v : g[u]){
        if (h[v] == -1){
            h[v] = h[u] + 1;
            dfs(v);
        }
    }
}

void dfs1(int v){
    mar.push_back(v);
    was[v] = true;
    for (auto u : g[v]){
        if (!was[u]){
            dfs1(u);
        }
    }
}

signed main(){
    int n;
    cin >> n;
    g.resize(n + 1);
    for (int i = 1; i < n; i++){
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    if (n <= 20){
        for (int i = 1; i <= n; i++){
            cout << i << "\n";
            fflush(stdout);
            int x;
            cin >> x;
            if (x == 0){
                cout << "! " << i;
                fflush(stdout);
                exit(0);
            }
        }
    }
    else{
        h.resize(n + 1, -1);
        h[1] = 0;
        dfs(1);
        int v = 1;
        for (int i = 2; i <= n; i++){
            if (h[v] < h[i]){
                v = i;
            }
        }
        was.resize(n + 1, false);
        dfs1(v);
        int l = -1, r = n;
        while (r - l > 1){
            int m = (l + r) / 2;
            cout << mar[m] << "\n";
            fflush(stdout);
            int x;
            cin >> x;
            if (x == 0){
                cout << "! " << mar[m];
                fflush(stdout);
                exit(0);
            }
            if (m < n - 1 && x == mar[m + 1]) l = m;
            else r = m;
        }
        if (r == n) cout << "! " << mar[l];
        else cout << "! " << mar[r];
        fflush(stdout);
        exit(0);
    }
}
