#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <deque>
#include <cmath>
#include <cassert>
#include <queue>

using namespace std;
typedef long long ll;
#define int long long 

int n, m, q;

vector <pair <int, signed>> a;

const int inf = 1e9;
int mini = inf;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> m >> q;
	a.push_back({ 0, 0 });

	for (int i = 1; i <= q; ++i)
	{
		int l, r;
		cin >> l >> r;
		--l; --r;


		while (true)
		{
			int len = r - l + 1;

			if (r % m < l % m)
			{
				a.push_back({ l % m, 1 });
				l = (l / m + 1) * m;
			}
			else if (len <= m)
			{
				a.push_back({ l % m, 1 });
				a.push_back({ r % m + 1, -1 });
				break;
			}
			else if (l != 0)
			{
				a.push_back({ l % m, 1 });
				l = (l / m + 1) * m;
			}
			else if (r% m < m - 1)
			{
				a.push_back({ r % m, 1 });
				a.push_back({ r % m + 1, -1 });
				a.push_back({ 0,  len / m });
				break;
			}
			else
			{
				a.push_back({ 0,  len / m });
				break;
			}
		}
	}

	sort(a.begin(), a.end());
	vector <pair <int, int>> b;
	for (auto& i : a)
	{
		if (b.empty() || b.back().first != i.first)
		{
			b.push_back(i);
		}
		else
		{
			b.back().second += i.second;
		}
	}


	int sum = 0;
	for (auto i : b)
	{
		sum += i.second;
		if (i.first < m) mini = min(mini, sum);

	}

	cout << mini;
	return 0;
}