#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <deque>
#include <cmath>
#include <cassert>
#include <queue>
#include <unordered_set>
#include <unordered_map>

using namespace std;
typedef long long ll;

int n, k, A;
string s[10010];
unordered_map<string, int> cnt[20];
string all;

bool ishere(const string& s)
{
	for (int j = 0; j < k; ++j)
	{
		string f = s.substr(0, j) + s.substr(j + 1, k - j - 1);
		if (cnt[j][f]) return true;
	}
	return false;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> k >> A;
	cin >> all;

	for (int i = 1; i <= n; ++i)
	{
		cin >> s[i];
		for (int j = 0; j < k; ++j)
		{
			string f = s[i].substr(0, j) + s[i].substr(j + 1, k - j - 1);
			cnt[j][f]++;
		}
	}


	for (int i = 1; i <= n; ++i)
	{
		for (int j = 0; j < k; ++j)
		{
			string f = s[i].substr(0, j) + s[i].substr(j + 1, k - j - 1);
			cnt[j][f]--;
		}

		string samp;
		int ans = 0;

		if (!ishere(s[i]))
		{
			samp = s[i];
			++ans;
		}

		for (int j = 0; j < k; ++j)
		{
			for (auto c : all) if (c != s[i][j])
			{
				string cp = s[i];
				cp[j] = c;
				if (!ishere(cp))
				{
					++ans;
					if (samp.empty()) samp = cp;
				}
			}
		}

		cout << ans << ' ' << samp << '\n';
		for (int j = 0; j < k; ++j)
		{
			string f = s[i].substr(0, j) + s[i].substr(j + 1, k - j - 1);
			cnt[j][f]++;
		}
	}

	return 0;
}