#include <iostream>
#include <vector>

using namespace std;


int main() {
    int n, m; cin >> n >> m;
    vector<vector<long long>> exam(n, vector<long long> (4));
    for (int i = 0; i < n; i ++) {
        cin >> exam[i][0] >> exam[i][1] >> exam[i][2] >> exam[i][3];
    }
    vector<vector<long long>> wend(m, vector<long long> (2));
    for (int i = 0; i < m; i ++) {
        cin >> wend[i][0] >> wend[i][1];
    }
    vector<vector<int>> info(n, vector<int> (3));
    for (int i = 0; i < n; i ++) {
        info[i][0] = 0;
        info[i][1] = 0;
        info[i][2] = 0;
    }
    int in_e = 0;
    int in_w = 0;
    int ans = 0;
    while ((in_w < m) & (in_e < n)) {
        while ((in_e < n) & (exam[in_e][3] < wend[in_w][0])) {
            in_e += 1;
        }
        if (in_e == n) {
            ans += m - in_w;
            break;
        }
        if (wend[in_w][1] < exam[in_e][0]) {
            ans += 1;
        } else if (wend[in_w][0] <= exam[in_e][1]) {
            if (wend[in_w][1] < exam[in_e][2]) {
                info[in_e][0] += 1;
            }
        } else if (wend[in_w][1] < exam[in_e][2]) {
            ans += 1;
        } else if (in_e == n - 1) {
            info[in_e][1] += 1;
        } else if (wend[in_w][1] < exam[in_e + 1][0]) {
            info[in_e][1] += 1;
        } else {
            info[in_e][2] += 1;
        }
        in_w += 1;
    }
    vector <int> dp_0(n, 0);
    vector <int> dp_1(n, 0);
    dp_0[0] = info[0][1];
    dp_1[0] = info[0][0];
    for (int i = 1; i < n; i ++) {
        dp_0[i] = max(dp_0[i - 1], dp_1[i - 1]) + info[i][1];
        dp_1[i] = max(dp_0[i - 1] + info[i - 1][2], dp_1[i - 1]) + info[i][0];
    }
    ans += max(dp_0[n - 1], dp_1[n - 1]);
    cout << ans;
}