#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define all(x) (x).begin(), (x).end()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template <typename T>
inline int len(const T& x) {
    return x.size();
}

const int inf = 1e9 + 9;
const ll llinf = 1e18 + 9;
const ll MOD = 1e9 + 7;
const int maxN = 1e5 + 9;
struct seg {
    int l, r;
};
int dp[maxN];
unordered_set<int> is[maxN];
bool inter(seg a, seg b) {
    return max(a.l, b.l) <= min(a.r, b.r);
}
int main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int n, m; cin >> n >> m;
    vector<seg> ex(2 * n);
    for(auto &i: ex) {
        cin >> i.l >> i.r;
    }

    vector<seg> fr(m);
    for(auto &i: fr) {
        cin >> i.l >> i.r;
    }

    for(int i = 0; i < m; ++i) {
        for(int j = 0; j < n; ++j) {
            if(inter(fr[i], ex[2 * j])) {
                is[i].insert(2 * j);
            }
            if(inter(fr[i], ex[2 * j + 1])) {
                is[i].insert(2 * j + 1);
            }
        }
    }

    for(int i = 0; i < m; ++i) {
        unordered_map<int, int> cnt;
        for(auto &j: is[i]) ++cnt[j / 2];
        bool bad = false;
        for(auto &j: cnt) if(j.second >= 2) bad = true;
        if(bad) {
            dp[i] = 0;
            continue;
        }

        vector<int> must;
        for(auto &j: cnt) {
            if(is[i].count(j.first * 2)) must.pb(j.first * 2 + 1);
            else must.pb(j.first * 2);
        }

        dp[i] = 1;

        for(int j = i - 1; j >= 0; --j) {
            bool ok = true;
            for(auto &k: must) {
                if(is[j].count(k)) {
                    ok = false;
                    break;
                }
            }
            if(ok) {
                dp[i] = max(dp[i], dp[j] + 1);
            }
        }

    }


    cout << *max_element(dp, dp + m) << '\n';

}
