#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define all(x) (x).begin(), (x).end()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template <typename T>
inline int len(const T& x) {
    return x.size();
}

const int inf = 1e9 + 9;
const ll llinf = 1e18 + 9;
const ll MOD = 1e9 + 7;
const int maxN = 2e5 + 9;
struct pt {
    ld x, y;
    pt operator-(const pt& sec) const {
        return pt{x - sec.x, y - sec.y};
    }
    ld operator%(const pt& sec) const {
        return x * sec.y - sec.x * y;
    }
};
vector<pt> s;
bool inside(pt a) {
    int L = 1, R = len(s);
    if((a - s[0]) % (s[1] - s[0]) > 0) return false;
    if((a - s[0]) % (s[R - 1] - s[0]) < 0) return false;

    while(R - L > 1) {
        int M = (L + R) / 2;
        if((a - s[0]) % (s[M] - s[0]) < 0) L = M;
        else R = M;
    }

    return (a - s[L]) % (s[R] - s[L]) <= 0;
}

int get_co(int n, int r) {
    int res = 0;
    for(int i = 1; i <= r; ++i) {
        if(__gcd(i, n) == 1) ++res;
    }
    return res;
}

int main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int n; cin >> n;
    s.assign(n, {0, 0});
    int mny = inf, mxy = -1;
    int M = 0;
    for(auto &i: s) {
        cin >> i.x >> i.y;
        mny = min(mny, (int) ceil(i.y));
        mxy = max(mxy, (int) floor(i.y));
    }

    for(int i = 0; i < n; ++i) {
        if(s[i].y < s[M].y) M = i;
    }

    ll ans = 0;
    int Lx = s[M].x, Rx = s[M].x;
    for(int i = mny; i <= mxy; ++i) {
        while(inside(pt{(ld) Lx - 1, (ld) i})) --Lx;
        while(!inside(pt{(ld) Lx, (ld) i})) ++Lx;

        while(inside(pt{(ld) Rx + 1, (ld) i})) ++Rx;
        while(!inside(pt{(ld) Rx, (ld) i})) --Rx;

        ans += get_co(i, Rx) - get_co(i, Lx - 1);
    }
    cout << ans << '\n';
}
