#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <string>

using namespace std;

typedef long long int ll;
typedef long double ld;

struct HashString{
    ll p = 29, q = 1000000007;
    vector<ll> h, pq;

    void init(string s){
        ll i, n = s.length();
        h.resize(n + 1);
        pq.resize(n + 1);
        pq[0] = 1;
        for(i = 0; i < n; i++){
            h[i + 1] = (h[i] * p + s[i] - 'a' + 1) % q;
            pq[i + 1] = (pq[i] * p) % q;
        }
    }

    ll get(ll l, ll r){
        return (((h[r] - h[l] * pq[r - l]) % q) + q) % q;
    }

};

int main(){
    ios::sync_with_stdio(false);cin.tie(NULL);cout.tie(NULL);
    ll n, pos, c, a, k, i, j, x, dist, counter;
    cin >> n >> k >> a;
    string s, t;
    cin >> s;
    vector<string> v(n), ans(n);
    vector<ll> cnt(n);
    for(i = 0; i < n; i++){
        cin >> t;
        v[i] = t;
    }
    for(i = 0; i < n; i++){
        for(pos = 0; pos < k; pos++){
            for(c = 0; c < a; c++){
                string tmp = v[i];
                tmp[pos] = s[c];
                counter = 0;
                for(j = 0; j < n; j++){
                    dist = 0;
                    for(x = 0; x < k; x++){
                        if(tmp[x] != v[j][x]){
                            dist++;
                        }
                    }
                    if(dist == 1){
                        counter++;
                    }
                    if(dist == 0){
                        counter = -n;
                    }
                }
                if(counter == 1){
                    cnt[i]++;
                    ans[i] = tmp;
                }
            }
        }
    }
    for(i = 0; i < n; i++){
        cout << cnt[i] << " " << ans[i] << "\n";
    }
    return 0;
}
