//#define _GLIBCXX_DEBUG 1

//#pragma GCC optimize("Ofast")
//#pragma GCC target("popcnt")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx,fma")


#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <deque>
#include <functional>
#include <set>
#include <map>
#include <random>
#include <memory>
#include <cassert>
#include <fstream>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <ctime>
#include <stack>
#include <queue>
#include <complex>
#include <chrono>
//#include <ext/pb_ds/detail/standard_policies.hpp>
//#include <ext/pb_ds/assoc_container.hpp>
//using namespace __gnu_pbds;


using namespace std;
using ll = long long;
using ul = unsigned long long;
using ld = long double;

template<typename T>
void print(T h, string s = " ") { for (auto ijkl : h) cout << ijkl << s; cout << "\n"; }

const long double EPS = 1e-8;
const long long INF = 2.5e18;
//#define int long long
#define vll vector <ll>
#define ve vector
#define sll set <ll>
#define hl pair <ll, ll>
#define printvhl(h) for (auto ijkl : h) cerr << ijkl.ft << ":" << ijkl.sd << " "; cerr << "\n";
#define scan(h, n) for (int ijkl = 0; ijkl < n; ++ijkl) cin >> h[ijkl]
#define pow2(n) ((n) * (n))
#define pow3(n) ((n) * (n) * (n))
#define all(x) (x).begin(), (x).end()
#define MOD ll(1000000007)
#define MOD2 ll(998244353)
#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front
#define ft first
#define sd second
#define look1(x)          cerr << #x << ": " << (x) << "\n";
#define look2(x, y)       cerr << #x << ": " << (x) << " | " << #y << ": " << (y) << "\n";
#define look3(x, y, z)    cerr << #x << ": " << (x) << " | " << #y << ": " << (y) << " | " << #z << ": " << (z) << "\n";
#define look4(a, b, c, d) cerr << #a << ":" << (a) << " | " << #b << ":" << (b) << " | " << #c << ":" << (c) << " | " << #d << ":" << (d) << "\n";

ll pown(ll n, ll cnt, ll mod = INT64_MAX) {
	return cnt == 0 ? 1 % mod : (cnt % 2 ? pown(n * n % mod, cnt / 2, mod) * n % mod : pown(n * n % mod, cnt / 2, mod) % mod);
}

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
char alph[] = "abcdefghijklmnopqrstuvwxyz0123456789";

int np[10000010];

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	for (int i = 2; i < 10000000; ++i) {
		if (np[i] == 0) {
			for (int j = i; j <= 10000000; j += i) {
				if (!np[j]) np[j] = i;
			}
		}
	}
	int t;
	cin >> t;
	while (t--) {
		int a, b;
		cin >> a >> b;
		int ans = 1;
		ve<int> dela;
		ve<int> delb;
		while (a != 1) {
			dela.pb(np[a]);
			a = a / np[a];
		}
		while (b != 1) {
			delb.pb(np[b]);
			b = b / np[b];
		}
		reverse(all(dela));
		reverse(all(delb));
		for (int i = 0; i < min(dela.size(), delb.size()); ++i) {
			if (dela[i] != delb[i]) break;
			ans *= dela[i];
		}
		cout << ans << "\n";
	}
	return 0;
}