#include <iostream>
#include <cmath>
#include <algorithm>
#include <memory.h>
#include <iomanip>
#include <string>
#include <sstream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <stack>
#include <deque>
#include <queue>
#include <random>
#include <stdio.h>
#include <ctime>
#include <chrono>
#define int long long
#define all(vc) vc.begin(), vc.end()
#define double long double
#define pii pair<int, int>
#define fir first
#define sec second
#define sp system("pause")
#define INF 1000000009
//#define endl '/n'
#define pb push_back
using namespace std;

const int N = 1000007, MOD = 1e9 + 7, R = 1 << 19;

vector<int> lvl(N, 0);
vector<vector<int>> mp(N, {});

void bfs(vector<vector<int>> &gr, int v)
{
	lvl[v] = 1;
	mp[1].pb(v);

	queue<int> q;
	q.push(v);

	while (!q.empty())
	{
		int u = q.front();
		q.pop();

		for (auto i : gr[u])
		{
			if (!lvl[i])
			{
				lvl[i] = lvl[u] + 1;
				mp[lvl[u] + 1].push_back(i); // = i;
				q.push(i);
			}
		}
	}

	return;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	/*if (n <= 20)
	{
		vector<vector<int>> gr(n);

		for (int i = 0; i < n - 1; i++)
		{
			int a, b;
			cin >> a >> b;
			a--;
			b--;

			gr[a].push_back(b);
			gr[b].push_back(a);
		}

		for (int i = 0; i < n; i++)
		{
			cout << i + 1 << endl;


			int k;
			cin >> k;

			if (k == 0)
			{
				cout << "! " << i  + 1 << endl;
				return 0;
			}
		}
	}
	else*/
	{
		vector<vector<int>> gr(n);

		for (int i = 0; i < n - 1; i++)
		{
			int a, b;
			cin >> a >> b;
			a--;
			b--;

			gr[a].push_back(b);
			gr[b].push_back(a);
		}

		int list = 0;

		for (int i = 0; i < n; i++)
		{
			if (gr[i].size() == 1)
				list = i;
		}

		bfs(gr, list);

		int l = 0, r = n + 1;

		while (r - l > 1)
		{
			int m = (r + l) / 2;

			int v = mp[m][0];

			cout << v << endl;

			int k;
			cin >> k;

			if (k == 0)
			{
				cout << "! " << k << endl;
				return 0;
			}

			if (lvl[k] < lvl[v])
			{
				r = m;
			}
			else
			{
				l = m;
			}
		}

		if (l == 0)
		{
			cout << "! " << mp[r][0] << endl;
			return 0;
		}

		if (r > n)
		{
			cout << "! " << mp[l][0] << endl;
			return 0;
		}

		cout << mp[r][0] << endl;

		int k;
		cin >> k;

		if (k == 0){
			cout << "! " << mp[r][0] << endl;
			return 0;
		}
		else
		{
			cout << "! " << mp[l][0] << endl;
			return 0;
		}

		return 0;
	}
}