#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

signed main() {

    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    
    int n, m, q;
    std::cin >> n >> m >> q;
    std::vector<int> ans(n * m);
    for (int i = 0; i < q; ++i) {
        int left, right;
        std::cin >> left >> right;
        --left, --right;
        for (int j = left; j <= right; ++j) {
            ++ans[j]; 
        }
    }
    std::vector<int> cnt(n);
    for (int i = 0; i < n * m; ++i) {
        cnt[i % m] += ans[i];
    }
    int min = 1e9;
    for (int i = 0; i < n; ++i) {
        if (cnt[i] < min) {
            min = cnt[i];
        }
    }
    std::cout << min;
    return 0;
}