#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define pb push_back
#define mp make_pair
#define fr first
#define sc second
#define all(arr) arr.begin(), arr.end()
#define rall(arr) arr.rbegin(), arr.rend()

vector<vector<int>> adj;
vector<int> siz;
vector<bool> mark;

void sizes(int p, int v){
    siz[v] = 1;
    for(auto u: adj[v]){
        if(u != p && !mark[u]){
            sizes(v, u);
            siz[v] += siz[u];
        }
    }
}

int find_centroid(int p, int v, int n){
    int mx_sub = -1;
    for(auto u: adj[v]){
        if(!mark[u] && u != p && siz[u] >= n / 2){
            mx_sub = u;
            break;
        }
    }

    if(mx_sub == -1) return v;
    return find_centroid(v, mx_sub, n);
}

int ask(int x){
    cout << x + 1 << endl;
    int ans; cin >> ans;
    return ans - 1;
}

int rec(int v = 0){
    sizes(v, v);
    v = find_centroid(v, v, siz[v]);
    mark[v] = 1;

    int to = ask(v);
    if(to == -1) return v;
    return rec(to);
}

void solve(){
    int n;
    cin >> n;

    adj.resize(n);
    siz.resize(n);
    mark.assign(n, 0);
    for(int i = 1; i < n; ++i){
        int u, v;
        cin >> u >> v;
        --u, --v;
        adj[u].pb(v);
        adj[v].pb(u);
    }

    int ans = rec() + 1;
    cout << "! " << ans << endl;
}

int main(){
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int tt = 1;
//    cin >> tt;

    while(tt--) solve();

    return 0;
}
