#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#define int long long
using namespace std;


void speed_fun(){
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}

vector<int> del(int x){
    vector<int> out;
    int i = 2;
    while (i * i <= x){
        while (x % i == 0){
            out.push_back(i);
            x /= i;
        }
        i++;
    }
    if (x > 1){
        out.push_back(x);
    }
    reverse(out.begin(), out.end());
    return out;
}

signed main() {
    speed_fun();
    int n; cin >> n;
    for (int _ = 0; _ < n; _++){
        int a, b; cin >> a >> b;
        if (a == 1 || b == 1){
            cout << 1 << '\n';
            continue;
        }
        vector<int> d1 = del(a), d2 = del(b);
        int i = 0;
        while (i < d1.size() && i < d2.size() && d1[i] == d2[i])
            i++;
        int s = 1;
        for (int j = 0; j < i; j++){
            s *= d1[j];
        }
        cout << s << '\n';
    }
}
