#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <map>

using namespace std;

void dfs(int v, int p, int lvl, vector<vector<int>>& g, vector<int>& h, vector<vector<int>>& dp) {
    h[v] = lvl;
    dp[v][0] = p;
    for (int u : g[v]) {
        if (u == p)
            continue;
        dfs(u, v, lvl + 1, g, h, dp);
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n; cin >> n;
    vector<vector<int>> g(n);
    vector<vector<int>> dp(n, vector<int>(20, 0));
    for (int i = 0; i < n - 1; i++) {
        int u, v; cin >> u >> v; u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<int> h(n);
    dfs(0, -1, 0, g, h, dp);
    int v = n - 1;
    for (int j = 19; j >= 0; j--) {
        cout << dp[v][j] + 1 << flush;
        int x; cin >> x; x--;
        if (x == -1)
            break;
        if (h[dp[v][j]] >= h[x])
            v = dp[v][j];
    }
    cout << "! " << v;
    return 0;
}